;;; DO NOT MODIFY THIS FILE
(if (featurep 'jde-custom-defines) (error "Feature jde-custom-defines already loaded"))

;;;### (autoloads (bsh-script-menu-definition bsh-startup-directory bsh-vm-args bsh-eval-timeout bsh-startup-timeout bsh-classpath bsh-vm bsh-jar bsh) "beanshell" "lisp/beanshell.el")
(defconst custom-define-current-source-file "beanshell.el")

(defgroup bsh nil "Customizations for the Emacs inteface to Pat Neimeyer's Java\ninterpreter, the Beanshell." :group 'tools :prefix "bsh-")

(defcustom bsh-jar "bsh.jar" "\
Path to the jar file containing the BeanShell classes." :group 'bsh :type 'file)

(defcustom bsh-vm nil "\
Java vm to be used to run the standalone BeanShell. By default,
bsh uses the first vm that it finds on the Emacs
`exec-path' (usually the same as your system's command
path). To specify a vm, select Path and enter the
path to the vm. " :group 'bsh :type '(choice (const :tag "Default" :value nil) (file :tag "Path")))

(defcustom bsh-classpath nil "\
Startup classpath for the BeanShell." :group 'bsh :type '(repeat (file :tag "Path")))

(defcustom bsh-startup-timeout 10 "\
*Length of time Emacs waits for the Beanshell to startup.
Increase the value of this variable if you get Lisp errors on
BeanShell startup on Unix. Setting this value on some versions of
XEmacs, e.g., Windows, seems to cause premature timeouts.  If you keep
getting timeout errors no matter how large a value you set, try
setting this variable to no timeout (nil)." :group 'bsh :type '(choice (const :tag "No timeout" :value nil) (number :tag "Length")))

(defcustom bsh-eval-timeout 30 "\
*Length of time in seconds Emacs waits for the Beanshell to
evaluate a Java expression before giving up and signaling an
error. Setting this value on some versions of XEmacs, e.g., Windows,
seems to cause premature timeouts. If you keep getting timeout errors
no matter how large a value you set, try setting this variable to no
timeout (nil)." :group 'bsh :type '(choice (const :tag "No timeout" :value nil) (number :tag "Length")))

(defcustom bsh-vm-args nil "\
*Specify arguments to be passed to the Java vm.
This option allows you to specify one or more arguments to be passed
to the Java vm that runs the BeanShell. Note that the value of this
variable should be a list of strings, each of which represents an
argument. When customizing this variable, use a separate text field
for each argument." :group 'bsh :type '(repeat (string :tag "Argument")))

(defcustom bsh-startup-directory "" "\
Path of directory in which to start the beanshell.
The path may start with a tilde (~) indication your
home directory and may include environment variables.
If this variable is the null string (the default), 
the beanshell starts in the directory of the current
buffer." :group 'bsh :type 'directory)

(defcustom bsh-script-menu-definition (list "Bsh" ["Help" bsh-script-help t]) "\
Definition of menu for BeanShell script buffers." :group 'bsh :type 'sexp :set '(lambda (sym val) (set-default sym val) (if (or (not (featurep 'xemacs)) (featurep 'infodock)) (easy-menu-define bsh-script-menu bsh-script-mode-map "Menu for BeanShell Script Buffer." val)) (if (and (featurep 'xemacs) (eq major-mode 'bsh-script-mode)) (bsh-script-insert-menu-in-xemacs-menubar))))

;;;***

;;;### (autoloads (jde-ant-working-directory jde-ant-build-hook jde-ant-target-regexp jde-ant-use-global-classpath jde-ant-complete-target jde-ant-enable-find jde-ant-read-args jde-ant-read-target jde-ant-read-buildfile jde-ant-buildfile jde-ant-args jde-ant-program jde-ant-user-jar-files jde-ant-home jde-ant-invocation-method jde-ant) "jde-ant" "lisp/jde-ant.el")
(defconst custom-define-current-source-file "jde-ant.el")

(defgroup jde-ant nil "JDE Ant" :group 'jde :prefix "jde-ant-")

(defcustom jde-ant-invocation-method (list "Script") "\
*Specifies how to invoke ant. Ant can be invoked in one of three
ways. The first is via the ant script/program that comes with ant.
The second is via java and the third is via the Ant Server." :group 'jde-ant :type '(list (radio-button-choice (const "Script") (const "Java") (const "Ant Server"))))

(defcustom jde-ant-home "" "\
*Directory where ant is installed." :group 'jde-ant :type 'file)

(defcustom jde-ant-user-jar-files nil "\
*Specifies jar files that hold user-defined tasks." :group 'jde-ant :type '(repeat (file :tag "Path")))

(defcustom jde-ant-program "ant" "\
*Specifies name of ant program/script." :group 'jde-ant :type 'string)

(defcustom jde-ant-args "-emacs" "\
*Specifies arguments to be passed to make program." :group 'jde-ant :type 'string)

(defcustom jde-ant-buildfile "build.xml" "\
*Specifies the default buildfile to use." :group 'jde-ant :type 'string)

(defcustom jde-ant-read-buildfile nil "\
*Specify whether to prompt for a buildfile. If non-nil, the jde-ant-build
command prompts you for an ant buildfile.  Note that when `jde-ant-enable-find'
is enable the value entered for `jde-ant-read-buildfile' is used as a
default. If no value is entered, or the file is non-existent, or is a
directory, the code tries to find the buildfile." :group 'jde-ant :type 'boolean)

(defcustom jde-ant-read-target nil "\
*Specify whether to prompt for a build target. If non-nil, the 
jde-ant-build command prompts you for an ant target." :group 'jde-ant :type 'boolean)

(defcustom jde-ant-read-args nil "\
*Specify whether to prompt for additional arguments to pass to ant. If
non-nil, the jde-ant-build command prompts you for the additional arguments." :group 'jde-ant :type 'boolean)

(defcustom jde-ant-enable-find nil "\
*Specify whether jde-ant find the build.xml file based on your current
directory. If non-nil, we will search up the directory hierarchy from the
current directory for the build definition file. Also note that, if non-nil,
this will relax the requirement for an explicit jde project file.  If
`jde-ant-read-buildfile' is enable that value is used as a default if valid." :group 'jde-ant :type 'boolean)

(defcustom jde-ant-complete-target t "\
*Specify whether to enable completion of build target names in the
minibuffer.

If non-nil, the jde-ant-build command allows you to use tab completion
in the minibuffer to specify the build target name.  This list of
valid build targets is determined by parsing the Ant build file.  This
option has no effect if jde-ant-read-target is nil." :group 'jde-ant :type 'boolean)

(defcustom jde-ant-use-global-classpath nil "\
*Specify whether to enable use of `jde-global-classpath' when running jde-ant." :group 'jde-ant :type 'boolean)

(defcustom jde-ant-target-regexp "<\\s-*target\\s-[^...]*?name\\s-*=\\s-*\"\\s-*\\([^\"]+\\)" "\
*Regular expression used to match target names in Ant build files." :group 'jde-ant :type 'string)

(defcustom jde-ant-build-hook '(jde-compile-finish-kill-buffer jde-compile-finish-refresh-speedbar jde-compile-finish-update-class-info) "\
*List of hook functions run by `jde-ant-build' (see `run-hooks'). Each
function should accept two arguments: the compilation buffer and a string
describing how the compilation finished" :group 'jde-ant :type 'hook)

(defcustom jde-ant-working-directory "" "\
*Path of the working directory to use in 'ant' build mode. This string must
end in a slash, for example, c:/foo/bar/ or ./ . If this string is empty, the
'ant' build mode uses the current file location as its working directory." :group 'jde-ant :type 'string)

;;;***

;;;### (autoloads (jde-bug-key-bindings jde-bug-stack-info jde-bug-local-variables jde-bug-window-message jde-bug-window jde-bug-breakpoint-cursor-colors jde-bug-saved-breakpoints jde-bug-debugger-command-timeout jde-bug-debugger-host-address jde-bug-server-shmem-name jde-bug-server-socket jde-bug-raise-frame-p jde-bug-vm-executable jde-bug-jre-home jde-bug-jpda-directory jde-bug-debug jde-bug) "jde-bug" "lisp/jde-bug.el")
(defconst custom-define-current-source-file "jde-bug.el")

(defgroup jde-bug nil "JDEbug General Options" :group 'jde :prefix "jde-bug")

(defcustom jde-bug-debug nil "\
*IMPORTANT!!!! Leave this switch in its default state (off) unless
you need to modify the *JDEbug* Java source code. Setting this switch
on causes the JDE to load *JDEbug* from its java/classes directory
instead of from jde.jar. It also causes the JDE to run the debugger in
debug server mode. This allows you to use *JDEbug* to debug itself." :group 'jde-bug :type 'boolean)

(defcustom jde-bug-jpda-directory "" "\
*Pathname of the directory containing Sun's Java Platform Debug Architecture
distribution. You need to set this variable only if this project uses a JDK 1.2 vm." :group 'jde-bug :type 'file)

(defcustom jde-bug-jre-home "" "\
*Home directory of the JRE containing the executable used to 
run debuggee processes.   
This variable specifies the home directory of the Java runtime
environment containing the executable, e.g., java, to be used to
launch processes (see `jde-bug-vm-executable'). If you do not specify
a home directory, the home directory is the same as that of the
executable used to run the debugger itself." :group 'jde-bug :type 'string)

(defcustom jde-bug-vm-executable (list (if (eq system-type 'windows-nt) "javaw" "java")) "\
*Name of the executable used to launch target processes.
This defaults to java on Unix platforms and javaw on Windows platforms" :group 'jde-bug :type '(list (radio-button-choice (const "java") (const "javaw") (const "java_g"))))

(defcustom jde-bug-raise-frame-p t "\
*Raise frame when a breakpoint is hit." :group 'jde-bug :type 'boolean)

(defcustom jde-bug-server-socket (cons t "2112") "\
*Socket where debugger listens for apps needing debugger services.
You can arrange for a vm to connect to JDEbug via a socket by starting it with the
options -Xdebug and -Xrunjdwp:transport=dt_socket,address=MYHOST:NNNN,
where MYHOST is the name of the machine running the debugger and
NNNN is the socket specified by this variable. To connect via shared
memory, start the debuggee process with the options -Xdebug and
-Xrunjdwp:transport=dt_shmem,address=ANYSTRING, where ANYSTRING is
the value of this variable. If you are running JDK 1.2, you must also
specifiy the options  -Xnoagent and -Djava.compiler=NONE." :group 'jde-bug :type '(cons (boolean :tag "Prompt for") (string :tag "Address")))

(defcustom jde-bug-server-shmem-name (cons t "JDEbug") "\
*Shared memory name under which the debugger listens for apps 
needing debugger services. To connect via shared
memory, start the debuggee process with the options -Xdebug and
-Xrunjdwp:transport=dt_shmem,address=ANYSTRING, where ANYSTRING is
the value of this variable. If you are running JDK 1.2, you must also
specifiy the options  -Xnoagent and -Djava.compiler=NONE." :group 'jde-bug :type '(cons (boolean :tag "Prompt for") (string :tag "Name")))

(defcustom jde-bug-debugger-host-address (if jde-xemacsp (system-name) system-name) "\
*Address of system on which JDEbug is running.
The default value is the value of the standard Emacs variable `system-name'.
The JDE uses the host address to connect to JDEBug during startup. On some Windows
systems, the JDE is unable to connect to the debugger socket under the system name.
If this happens, you can try setting this variable to the absolute address of 
a local host: 127.0.0.1 ." :group 'jde-bug :type 'string)

(defcustom jde-bug-debugger-command-timeout 30 "\
*Length of time in seconds the JDE waits for a response from the debugger to a command." :group 'jde-bug :type 'integer)

(defcustom jde-bug-saved-breakpoints nil "\
*Breakpoints to be set for the current project." :group 'jde-bug :type '(repeat (cons :tag "Break at" (string :tag "File Name") (integer :tag "Line Number"))))

(defcustom jde-bug-breakpoint-cursor-colors (cons "cyan" "brown") "\
*Specifies the foreground and background colors of the debugger's
breakpoint cursor." :group 'jde-bug :type '(cons (string :tag "Foreground Color") (string :tag "Background Color")) :set '(lambda (sym val) (make-face 'jde-bug-breakpoint-cursor) (set-face-foreground 'jde-bug-breakpoint-cursor (car val)) (set-face-background 'jde-bug-breakpoint-cursor (cdr val)) (set-default sym val)))

(defgroup jde-bug-window nil "JDEbug Window Preferences" :group 'jde-bug :prefix "jde-bug-window")

(defcustom jde-bug-window-message nil "\
Message buffer window preferences." :group 'jde-bug-window :type 'list)

(defcustom jde-bug-local-variables nil "\
A non nil values makes the JDEBug
retrieve the local variables after every step command. It is recommended to
enable this feature just when is needed since retrieving the local variables
is time consuming and slow down stepping through the code." :group 'jde-bug :type 'boolean)

(defcustom jde-bug-stack-info nil "\
A non nil values makes the JDEBug retrieve
the stack info every step command. It is recommended to enable
this feature just when is needed since retrieving the stack info is time
consuming and slows down stepping through the code." :group 'jde-bug :type 'boolean)

(defcustom jde-bug-key-bindings (list (cons "[? ? ?]" 'jde-bug-step-over) (cons "[? ? ?]" 'jde-bug-step-into) (cons "[? ? ?]" 'jde-bug-step-into-all) (cons "[? ? ?]" 'jde-bug-step-out) (cons "[? ? ?]" 'jde-bug-continue) (cons "[? ? ?]" 'jde-bug-toggle-breakpoint)) "\
*Specifies key bindings for JDEbug.
The value of this variable is an association list. The car of
each element specifies a key sequence. The cdr specifies 
an interactive command that the key sequence executes. To enter
a key with a modifier, type C-q followed by the desired modified
keystroke. For example, to enter C-s (Control s) as the key to be
bound, type C-q C-s in the key field in the customization buffer.
You can use the notation [f1], [f2], etc., to specify function keys." :group 'jde-bug :type '(repeat (cons :tag "Key binding" (string :tag "Key") (function :tag "Command"))) :set '(lambda (sym val) (if (and (boundp 'jde-bug-key-bindings) jde-bug-key-bindings) (mapc (lambda (binding) (let ((key (car binding)) (fcn (cdr binding))) (if (string-match "\\[.+]" key) (setq key (car (read-from-string key)))) (define-key jde-bug-mode-map key nil))) jde-bug-key-bindings)) (mapc (lambda (binding) (let ((key (car binding)) (fcn (cdr binding))) (if (string-match "\\[.+]" key) (setq key (car (read-from-string key)))) (define-key jde-bug-mode-map key fcn))) val) (set-default sym val)))

;;;***

;;;### (autoloads (jde-checkstyle-source-file-extension jde-checkstyle-finish-hook jde-checkstyle-source-dir jde-checkstyle-output-format jde-checkstyle-output-file jde-checkstyle-module-package-names-file jde-checkstyle-expanded-properties-file jde-checkstyle-expanded-properties jde-checkstyle-style jde-checkstyle-read-args jde-checkstyle-classpath jde-checkstyle-class jde-checkstyle) "jde-checkstyle" "lisp/jde-checkstyle.el")
(defconst custom-define-current-source-file "jde-checkstyle.el")

(defgroup jde-checkstyle nil "This group specifies options for the JDEE's interface to the CheckStyle \npackage (http://checkstyle.sourceforge.net). The CheckStyle package\nchecks Java source files for conformity to a specified coding\nstyle." :group 'jde)

(defcustom jde-checkstyle-class "com.puppycrawl.tools.checkstyle.Main" "\
*Java checker class.
Specifies the class of the the program to be used to check the source
in the current buffer. The default is the checkstyle program." :group 'jde-checkstyle :type 'string)

(defcustom jde-checkstyle-classpath nil "\
*Specify paths of classes required to run the jde-checkstyle application.
The JDE uses the specified paths to construct a -classpath
argument to pass to the Java interpreter. This option overrides the
`jde-global-classpath' option." :group 'jde-checkstyle :type '(repeat (file :tag "Path")))

(defcustom jde-checkstyle-read-args nil "\
*Specify whether to prompt for additional checker arguments.
If this variable is non-nil, the jde-checkstyle command prompts
you to enter additional checker arguments in the minibuffer.
These arguments are appended to those specified by customization
variables. The JDE maintains a history list of arguments 
entered in the minibuffer." :group 'jde-checkstyle :type 'boolean)

(defcustom jde-checkstyle-style nil "\
*Style used to check this project's Java code. \"Sun\"
checks for conformity to the Java code style standard established by
Sun Microsystems. \"Custom\" specifies a a user-defined
style. Selecting this option causes Emacs to display an edit
field. Enter the path of a CheckStyle configuration file that defines
the custom coding style in this field (see the CheckStyle
documentation for information on configuration files). Use
`jde-checkstyle-properties' to specify the values of properties that
the configuration file reads from the CheckStyle command line." :group 'jde-checkstyle :type '(choice (const :tag "Sun" :value nil) (file :menu-tag "Custom" :tag "Config. File")))

(defcustom jde-checkstyle-expanded-properties nil "\
*Specify the values of the expanded properties specified by the
`jde-checkstyle-style' configuration file. (See the CheckStyle
documentation for information about expanded properties.) To enter a
property, select the INS button. Emacs displays a Property Name field
and a Property Value field for the property. Enter the name of the
property, for example, checkstyle.header.file, in the Property Name
field; enter its value, for example, docs/java.header, in the Property
Value field.  Repeat this process to display additional
properties. You can specify as many properties as you like in
this way. To delete a property, select the DEL button next
to the property." :group 'jde-checkstyle :type '(repeat (cons (string :tag "Property Name") (string :tag "Property Value"))))

(defcustom jde-checkstyle-expanded-properties-file nil "\
*Path of a file that specifies the values of a configuration
file's expanded properties. If this option is set, the JDEE ignores
the settings of the `jde-checkstyle-expanded-properties' variable." :group 'jde-checkstyle :type '(choice (const :tag "None" :value nil) (file :menu-tag "Properties File" :tag "Path")))

(defcustom jde-checkstyle-module-package-names-file nil "\
*Path of a file that specifies the package names of 
custom style checking modules used by this project." :group 'jde-checkstyle :type '(choice (const :tag "None" :value nil) (file :menu-tag "Package Names File" :tag "Path")))

(defcustom jde-checkstyle-output-file nil "\
*Path of a file to store CheckStyle's output." :group 'jde-checkstyle :type '(choice (const :tag "None" :value nil) (file :menu-tag "Output File" :tag "Path")))

(defcustom jde-checkstyle-output-format nil "\
*Format of CheckStyle's output. Options are plain or XML." :group 'jde-checkstyle :type '(choice (const :tag "Plain" :value nil) (const :tag "XML" :value "xml")))

(defcustom jde-checkstyle-source-dir nil "\
*Path of a directory to check. If you specify a 
path, CheckStyle checks all the files in the specified
directory. Otherwise, it checks the file in the current
buffer." :group 'jde-checkstyle :type '(choice (const :tag "None" :value nil) (file :menu-tag "Source Directory" :tag "Path")))

(defcustom jde-checkstyle-finish-hook '(jde-compile-finish-kill-buffer) "\
List of functions to be invoked when CheckStyle terminates.  Each
function should accept two arguments: the compilation buffer and a
string describing how the compilation finished." :group 'jde-checkstyle :type 'hook)

(defcustom jde-checkstyle-source-file-extension nil "\
*Extension of Java source files (if not java)." :group 'jde-checkstyle :type '(choice (const :tag "java" :value nil) (string :menu-tag "other" :tag "Extension")))

;;;***

;;;### (autoloads (jde-built-class-path) "jde-class" "lisp/jde-class.el")
(defconst custom-define-current-source-file "jde-class.el")

(defcustom jde-built-class-path nil "\
Similar to `jde-global-classpath', except this path should only
have those places where compile files live.  This list of paths could
contain both directories and jar files.  Each of these should
correspond to the root of the build tree, in other words the
directories under it should correpond to packages." :group 'jde-project :type '(repeat (file :tag "Path")))

;;;***

;;;### (autoloads (jde-compile-enable-kill-buffer jde-compile-option-verbose-path jde-compile-option-extdirs jde-compile-option-bootclasspath jde-compile-option-target jde-compile-option-source jde-compile-option-encoding jde-compile-option-nowarn jde-compile-option-verbose jde-compile-option-vm-args jde-compile-option-depend-switch jde-compile-option-depend jde-compile-option-optimize jde-compile-option-debug jde-compile-option-deprecation jde-compile-option-directory jde-compile-option-sourcepath jde-compile-option-classpath jde-compile-option-command-line-args jde-compile-jump-to-first-error jde-compile-option-hide-classpath jde-compile-finish-hook jde-read-compile-args jde-compiler jde-compile-options) "jde-compile" "lisp/jde-compile.el")
(defconst custom-define-current-source-file "jde-compile.el")

(defgroup jde-compile-options nil "JDE Compiler Options" :group 'jde :prefix "jde-compile-option-")

(defcustom jde-compiler '("javac server" "") "\
Specify the type, and if necessary, the location of the compiler to
be used to compile source files for the current project. The JDE
supports three compilers: javac server, javac executable, and
jikes. The javac server runs the com.sun.tools.javac package included
with the JDK in the Beanshell. The javac executable shipped with the
JDK also uses this package. The advantage of the javac server is that
it avoids the vm startup time that accounts for most of the
compilation time consumed by the javac executable. The javac server
uses the version of com.sun.tools.javac included in the JDK for the
current project. See `jde-jdk' for more information. If you want to
use the javac executable to compile your project's source files,
select \"javac\" as the compiler type and, optionally, specify
the path to the executable in the \"Path\" field. If you do
not specify a path, the JDE uses the javac executable included in the
JDK for the current project. Similarly, to use jikes, select \"jikes\"
and, if jikes is not on the command path of the Emacs
environment, specify the path of the jikes executable." :group 'jde-project :type '(list (radio-button-choice :format "%t 
%v" :tag "Compiler type" (item "javac server") (item "javac") (item "jikes")) (file :tag "Path")))

(defcustom jde-read-compile-args nil "\
*Specify whether to prompt for additional compiler arguments.
If this variable is non-nil, the jde-compile command prompts
you to enter additional compiler arguments in the minibuffer.
These arguments are appended to those specified by customization
variables. The JDE maintains a history list of arguments 
entered in the minibuffer." :group 'jde-project :type 'boolean)

(defcustom jde-compile-finish-hook '(jde-compile-finish-kill-buffer jde-compile-finish-refresh-speedbar jde-compile-finish-update-class-info) "\
List of functions to be invoked when compilation of a 
Java source file terminates. Each function should accept
two arguments: the compilation buffer and a string 
describing how the compilation finished." :group 'jde :type 'hook)

(defcustom jde-compile-option-hide-classpath nil "\
Substitute the classpath in the compilation window for
..." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-jump-to-first-error t "\
*Automatically jump to the first error when a compilation process completes." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-option-command-line-args nil "\
*Specify options as a string of command-line arguments.
The value of this variable should be a list of switches understood
by the compiler, for example, -depend -g. This variable is intended to
be used to set compile options not otherwise defined by the JDE, in
particular, options not defined by javac but used by another compiler
that you might want to use with the JDE." :group 'jde-compile-options :type '(repeat (string :tag "Argument:")))

(defcustom jde-compile-option-classpath nil "\
*Specify paths of classes required to compile this project.
The JDE uses the specified paths to construct a -classpath
argument to pass to the compiler. This option overrides the
`jde-global-classpath' option." :group 'jde-compile-options :type '(repeat (file :tag "Path")))

(defcustom jde-compile-option-sourcepath nil "\
*Specify the source code path to search for class or interface definitions.

As with the user class path, source path entries  can be directories, JAR 
archives, or ZIP archives. If packages are used, the local path name within 
the directory or archive must reflect the package name. 

Note that classes found through the classpath are subject to automatic 
recompilation if their sources are found." :group 'jde-compile-options :type '(repeat (file :tag "Path")))

(defcustom jde-compile-option-directory "" "\
*Specifies the root directory of the class file hierarchy.
The compiler places compiled classes in the specified
directory. For example, specifying the class
directory as: 
  
  C:\\users\\dac\\classes

causes the class files for the classes in the MyProgram.java source
file to be saved in the directory C:\\users\\dac\\classes. If your class 
is in the package demos\\awt, the class files would be placed in directory
C:\\users\\dac\\classes\\demos\\awt." :group 'jde-compile-options :type 'directory)

(defcustom jde-compile-option-deprecation nil "\
*Warn use or override of a deprecated member or class. 
A member or class is deprecated if its documentation comment contains
the @deprecated tag. The compiler will emit a warning at the end of
compilation whether or not the deprecation option is on; this option
causes the location of each individual use or override to be noted.

Deprecated members or classes are deliberately not mentioned if the
source file containing the deprecation is being recompiled.  This can
happen because the file is on the command line or because the depend
option is on and the source file is out of date.
" :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-option-debug (list "selected" (list t nil nil)) "\
*Include debug information in classes.
The compiler includes line number information by default.

Before JDK 1.2, the the debug and optimize options were
mutually exclusive. In JDK 1.2, it is possible to combine debug and
optimize, but the shortcuts taken by optimized code may occasionally
produce surprising debugging results. For example, declared variables
may not exist and code may appear to move or not be executed at all.

The JDK 1.1.x versions of javac do not support inclusion of selected
debug information." :group 'jde-compile-options :type '(list (radio-button-choice :format "%t 
%v" :tag "Debug info to include in class:" (const "all") (const "none") (const "selected")) (list :tag "    info" :indent 4 (checkbox :format "%[%v%] %t 
" :tag "Line Numbers") (checkbox :format "%[%v%] %t 
" :tag "Variables") (checkbox :format "%[%v%] %t 
" :tag "Source"))))

(defcustom jde-compile-option-optimize nil "\
*Directs the compiler to try to generate faster code. 
This may slow down compilation, make larger class files, and/or make
it difficult to debug.

Prior to 1.2, the optimize option tried to inline methods across
classes. This created compatibility problems and sometimes generated
illegal bytecode. The optimize option also implicitly turned on the
depend option and implicitly turned off the debug option.

In JDK 1.2, the optimize option no longer inlines across classes and
so may safely be used for any java compilation. Optimize no longer
implicitly turns on depend or implicitly turns off debug." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-option-depend nil "\
*Analyze dependencies.
Causes recompilation of class files on which the source files given as
command line arguments recursively depend. Without this option, only
files that are directly depended on and missing or out-of-date will be
recompiled. Recompilation does not extend to missing or out-of-date
files only depended on by already up-to-date class files.

Note: if you are using a compiler other than post JDK 1.1.6 versions
of javac, you may need to specify the command-line switch used by
the compiler to specify dependency checking. See 
`jde-compile-option-depend-switch' for more information." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-option-depend-switch (list "-Xdepend") "\
*Specify command line switch for depend option.
This option is necessary because the command-line switch for
dependency checking differs among Java compilers. Choose
from the following options:

  -Xdepend  Full dependency checking (post JDK 1.1.6)
  -depend   Full dependency checking (jikes and pre-JDK 1.1.6)
  +F        Check everything except jar and zip files (jikes only)
  +U        Check everything including jar and zip files (jikes only)" :group 'jde-compile-options :type '(list (radio-button-choice :format "%t 
%v" :tag "Select -Xdepend (javac) or -depend (jikes):" (const "-Xdepend") (const "-depend") (const "+F") (const "+U"))))

(defcustom jde-compile-option-vm-args nil "\
*Specify command-line arguments for Java interpreter.
Passes the specified arguments to the Java interpreter that runs the
compiler. The argument should not contain spaces. This is useful for
adjusting the compiler's execution environment or memory usage." :group 'jde-compile-options :type '(repeat (string :tag "Option")))

(defcustom jde-compile-option-verbose nil "\
*Print verbose messages.
Causes the compiler and linker to print out messages about what source
files are being compiled and what class files are being loaded." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-option-nowarn nil "\
*Turn off warnings.
If this option is specified, the compiler does not print out any
warnings." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-option-encoding "" "\
*Specify the source file encoding name, such as EUCJIS\\SJIS.
If this option is not specified, then the platform default converter
is used." :group 'jde-compile-options :type 'string)

(defcustom jde-compile-option-source (list "default") "\
*Enables JDK version-specific features to be used in
source files.

  1.3 	  The compiler does not support assertions
  
  1.4     The compiler accepts code containing assertions. 

  1.5     Enables 1.5-specific features.

  Select \"default\" to use the source features that
  the compiler supports by default, i.e., to not include the -source
  switch on the compiler command line. For example, the javac compiler
  defaults to 1.3 source features if the -source flag is not
  used.

   ***NOTE***

   This option is supported only by versions of javac shipped
   starting with J2SDK 1.4." :group 'jde-compile-options :type '(list (radio-button-choice :format "%t 
%v" :tag "Source release:" (const "default") (const "1.3") (const "1.4") (const "1.5"))))

(defcustom jde-compile-option-target (list "1.1") "\
*Generate class files that will work on VMs with the specified version.
 
The default is to generate class files to be compatible with both
1.1 and 1.2 VMs. The versions supported by javac in JDK1.2 are: 

  1.1     Ensure that generated class files will be compatible 
          with 1.1 and 1.2 VMs. This is the default.
  
  1.2     Generate class files that will run on 1.2 VMs, but 
          not on 1.1 VMs.

  1.3     Generate class files that will run on VMs in the 
          Java 2 SDK, v 1.3 and later, but will not run 
          on 1.1 or 1.2 VMs

  1.4     Generate class files that are compatible only with
          1.4 VMs.

By default, classes are compiled against the bootstrap and extension classes
of the JDK that javac shipped with. But javac also supports cross-compiling, 
where classes are compiled against a bootstrap and extension classes of a 
different Java platform implementation. It is important to use 
`jde-compile-option-bootclasspath' and `jde-compile-option-extdirs' when 
cross-compiling." :group 'jde-compile-options :type '(list (radio-button-choice :format "%t 
%v" :tag "Target VM:" (const "1.1") (const "1.2") (const "1.3") (const "1.4"))))

(defcustom jde-compile-option-bootclasspath nil "\
*Cross-compile against the specified set of boot classes.
As with the user class path, boot class path entries can be 
directories, JAR archives, or ZIP archives." :group 'jde-compile-options :type '(repeat (file :tag "Path")))

(defcustom jde-compile-option-extdirs nil "\
*Cross-compile against the specified extension directories. 
Each JAR archive in the specified directories is searched for class files." :group 'jde-compile-options :type '(repeat (file :tag "Path")))

(defcustom jde-compile-option-verbose-path nil "\
*Describe how paths and standard extensions were searched to find
source and class files.

   ***NOTE***

   This option is supported only by the versions of javac shipped
   with JDK 1.1.x and 1.2.x and oldjavac in JDK 1.3." :group 'jde-compile-options :type 'boolean)

(defcustom jde-compile-enable-kill-buffer nil "\
* If true the 'jde-compile-finish-kill-buffer will kill the compilation
buffer." :group 'jde-compile-options :type 'boolean)

;;;***

;;;### (autoloads (jde-complete-classinfo-cache-size jde-complete-function jde-complete-display-throws jde-complete-display-result-type jde-complete-display-qualified-types jde-complete-insert-method-signature jde-complete-unique-method-names jde-complete-add-space-after-method jde-complete-signature-display-time jde-complete-signature-display jde-complete) "jde-complete" "lisp/jde-complete.el")
(defconst custom-define-current-source-file "jde-complete.el")

(defgroup jde-complete nil "JDE Completion" :group 'jde :prefix "jde-complete-")

(defcustom jde-complete-signature-display (list "Eldoc") "\
Display modes used to show the method signature after a completion.
The display modes choices are using eldoc-mode(the signature shows in the
minibuffer), a buffer(a one line buffer shows the signature and then
dissapears), or none." :group 'jde-complete :type '(list (radio-button-choice (const "Eldoc") (const "Buffer") (const "None"))))

(defcustom jde-complete-signature-display-time 5 "\
Amount of time in seconds to display the method signature
in the minibuffer after a completion." :group 'jde-complete :type 'integer)

(defcustom jde-complete-add-space-after-method nil "\
*If non nil it will add a space between the method
name and the first parenthesis. i.e foo () instead of foo() when using
the completion methods `jde-complete-in-line' and `jde-complete-menu'
After customizing this variable, be sure to use
`jde-complete-flush-classinfo-cache', any class information that was
previously cache is not going to be affected by this setting." :group 'jde-complete :type 'boolean)

(defcustom jde-complete-unique-method-names nil "\
If non nil it will display methods with the same name
 but with different signature only once, the signature for ths methods
 will be the signature of the first method in the list of completions
The list of completion is sorted in alphabetical order.
This variable modifies the completion for `jde-complete-menu'
and `jde-complete-in-line'. After customizing this variable,
be sure to use `jde-complete-flush-classinfo-cache',
any class information that was previously cache is not going to be affected by
this setting" :group 'jde-complete :type 'boolean)

(defcustom jde-complete-insert-method-signature t "\
If non nil it will insert the method signature when using
`jde-complete-in-line' and `jde-complete-menu'
i.e. v.get(int, java.lang.String). If `jde-complete-unique-method-names'
is non nil methods with the same name will get the signature of the first one
in the completion list. After customizing this variable, be sure to use
`jde-complete-flush-classinfo-cache', any class information that was
previously cache is not going to be affected by this setting" :group 'jde-complete :type 'boolean)

(defcustom jde-complete-display-qualified-types t "\
If non nil use fully qualified types when displaying methods for selection,
i.e. v.get(int, java.lang.String). If nil, use unqualified types, i.e.
v.get(int, String). After customizing this variable, be sure to use
`jde-complete-flush-classinfo-cache', any class information that was
previously cache is not going to be affected by this setting." :group 'jde-complete :type 'boolean)

(defcustom jde-complete-display-result-type t "\
If non nil include result type when displaying methods for selection.
After customizing this variable, be sure to use
`jde-complete-flush-classinfo-cache', any class information that was
previously cache is not going to be affected by this setting." :group 'jde-complete :type 'boolean)

(defcustom jde-complete-display-throws t "\
If non nil include thrown exceptions when displaying methods for selection.
After customizing this variable, be sure to use
`jde-complete-flush-classinfo-cache', any class information that was
previously cache is not going to be affected by this setting." :group 'jde-complete :type 'boolean)

(defcustom jde-complete-function 'jde-complete-menu "\
*Function that will be invoked by the `jde-complete-select' command.
The `jde-complete-menu' function displays completions for
the symbol at point in a popup menu. The `jde-complete-minibuf' function
displays completions in the minibuffer. You may also
specify a custom function to use. The custom function must
be an interactive function that can be called by 
`call-interactively'." :group 'jde-project :type '(choice (function-item jde-complete-menu) (function-item jde-complete-minibuf) (function-item jde-complete-in-line) (function :format "%t %v" :tag "Custom:")))

(defcustom jde-complete-classinfo-cache-size 50 "\
The max size of completion's cache.")

;;;***

;;;### (autoloads (jde-db-active-breakpoint-face-colors jde-db-requested-breakpoint-face-colors jde-db-spec-breakpoint-face-colors jde-db-log-debugger-output-flag jde-db-option-application-args jde-db-option-vm-args jde-db-option-connect-shared-memory-name jde-db-option-connect-socket jde-db-option-host jde-db-option-verify jde-db-option-heap-profile jde-db-option-java-profile jde-db-option-garbage-collection jde-db-option-stack-size jde-db-option-heap-size jde-db-option-properties jde-db-option-verbose jde-db-option-classpath jde-db-options jde-db-classic-mode-vm jde-db-read-app-args jde-db-read-vm-args jde-db-initial-step-p jde-db-mode-hook jde-db-query-missing-source-files) "jde-db" "lisp/jde-db.el")
(defconst custom-define-current-source-file "jde-db.el")

(defcustom jde-db-query-missing-source-files t "\
If nonnil, this variable causes the debugger to query you
for the path of a class source file that it cannot find in
`jde-sourcepath'." :group 'jde-project :type 'boolean)

(defcustom jde-db-mode-hook nil "\
*Customization hook for jde-db inferior mode." :group 'jde-project :type 'hook)

(defcustom jde-db-initial-step-p t "\
*If non-nil, this option causes the debugger
to issue a step-into command after launching
a program. This causes the vm to step to the
first line of the debuggee program." :group 'jde-project :type 'boolean)

(defcustom jde-db-read-vm-args nil "\
*Read vm arguments from the minibuffer.
If this variable is non-nil, the jde-db command reads vm arguments
from the minibuffer and appends them to those specified by
the `jde-db-option' variable group." :group 'jde-project :type 'boolean)

(defcustom jde-db-read-app-args nil "\
*Read arguments to be passed to application from the minibuffer." :group 'jde-project :type 'boolean)

(defcustom jde-db-classic-mode-vm nil "\
Runs applications in the classic (i.e., not HotSpot) mode when
debugging." :group 'jde-project :type 'boolean)

(defgroup jde-db-options nil "JDE Debugger Options" :group 'jde :prefix "jde-db-option-")

(defcustom jde-db-option-classpath nil "\
*Specify paths of classes required to run this application.
The JDE uses the specified paths to construct a -classpath
argument to pass to the Java interpreter. This option overrides the
`jde-global-classpath' option." :group 'jde-db-options :type '(repeat (file :tag "Path")))

(defcustom jde-db-option-verbose (list nil nil nil) "\
*Print messages about the running process.
The messages are printed in the run buffer." :group 'jde-db-options :type '(list :indent 2 (checkbox :format "
  %[%v%] %h 
" :doc "Print classes loaded.
Prints a message in the run buffer each time a class is loaded.") (checkbox :format "%[%v%] %h 
" :doc "Print memory freed.
Prints a message in the run buffer each time the garbage collector
frees memory.") (checkbox :format "%[%v%] %h 
" :doc "Print JNI info.
Prints JNI-related messages including information about which native
methods have been linked and warnings about excessive creation of
local references.")))

(defcustom jde-db-option-properties nil "\
*Specify property values.
Enter the name of the property, for example, awt.button.color, in the
Property Name field; enter its value, for example, green, in the
Property Value field. You can specify as many properties as you like." :group 'jde-db-options :type '(repeat (cons (string :tag "Property Name") (string :tag "Property Value"))))

(defcustom jde-db-option-heap-size (list (cons 1 "megabytes") (cons 16 "megabytes")) "\
*Specify the initial and maximum size of the interpreter heap." :group 'jde-db-options :type '(list (cons (integer :tag "Start") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes"))) (cons (integer :tag "Max") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes")))))

(defcustom jde-db-option-stack-size (list (cons 128 "kilobytes") (cons 400 "kilobytes")) "\
*Specify size of the C and Java stacks." :group 'jde-db-options :type '(list (cons (integer :tag "C Stack") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes"))) (cons (integer :tag "Java Stack") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes")))))

(defcustom jde-db-option-garbage-collection (list t t) "\
*Specify garbage collection options." :group 'jde-db-options :type '(list :indent 2 (checkbox :format "%[%v%] %t 
" :tag "Collect garbage asynchronously.") (checkbox :format "%[%v%] %t 
" :tag "Collect unused classes.")))

(defcustom jde-db-option-java-profile (cons nil "./java.prof") "\
*Enable Java profiling." :group 'jde-db-options :type '(cons boolean (file :tag "File" :help-echo "Specify where to put profile results here.")))

(defcustom jde-db-option-heap-profile (cons nil (list "./java.hprof" 5 20 "Allocation objects")) "\
*Output heap profiling data." :group 'jde-db-options :type '(cons boolean (list (string :tag "Output File Path") (integer :tag "Stack Trace Depth") (integer :tag "Allocation Sites") (radio-button-choice :format "%t 
%v" :tag "Sort output based on:" (const "Allocation objects") (const "Live objects")))))

(defcustom jde-db-option-verify (list nil t) "\
*Verify classes." :group 'jde-db-options :type '(list :indent 2 (checkbox :format "%[%v%] %t 
" :tag "Executed code in all classes.") (checkbox :format "%[%v%] %t 
" :tag "Classes loaded by a classloader.")))

(defcustom jde-db-option-host "" "\
Host of a remote process to which you wish to attach. This
option is invalid for JDK verions greater than JDK 1.1.x." :group 'jde-db-options :type 'string)

(defcustom jde-db-option-connect-socket (list nil "4444") "\
Specify address of socket to be used to connect the debugger and a
debuggee process. Selecting \"Prompt\" from the customization value
menu causes the debugger to prompt you to enter the shared memory name
when you command it to attach to or listen for an existing
process. Selecting \"Specify\" allows you to specify a default socket
host and port to be used by the debugger. " :group 'jde-db-options :type '(choice (const :menu-tag "Prompt" nil) (list :menu-tag "Specify" :tag "Socket Address" :inline nil (choice :tag "Host" (const :menu-tag "Local" nil) (string :menu-tag "Remote" :tag "Name")) (choice :tag "Port" (const :menu-tag "Default" "4444") (string :menu-tag "Custom")))))

(defcustom jde-db-option-connect-shared-memory-name "javadebug" "\
Specify name to use to establish a shared memory connection
between the debugger and a debuggee process. Selecting \"Prompt\" from
the customization value menu causes a debugger attach or listen
command, e.g., `jde-jdb-attach-via-shared-memory', to prompt you to
enter the shared memory name. Selecting \"Specify\" allows you to
specify a name of your choosing." :group 'jde-db-options :type '(choice (const :menu-tag "Prompt" nil) (string :menu-tag "Specify" :tag "Name")))

(defcustom jde-db-option-vm-args nil "\
*Specify arguments to be passed to the Java vm.
This option allows you to specify one or more arguments to be passed
to the Java interpreter. It is an alternative to using JDE Run Option
variables, such as `jde-run-option-stack-size', to specify Java
interpreter options. Also, it makes it possible to use the JDE with
interpreters that accept command line arguments not supported by 
the JDE Run Option variable set." :group 'jde-db-options :type '(repeat (string :tag "Argument")))

(defcustom jde-db-option-application-args nil "\
*Specify command-line arguments to pass to the application.
The JDE passes the specified arguments to the application on
the command line." :group 'jde-db-options :type '(repeat (string :tag "Argument")))

(defcustom jde-db-log-debugger-output-flag nil "\
Log raw debugger output to a buffer. This variable is intended
to be used for debugging the JDEE's debuggers." :group 'jde-db-options :type 'boolean)

(defcustom jde-db-spec-breakpoint-face-colors (cons "black" "green") "\
*Specifies the foreground and background colors used to highlight
the line at which you have specified that a breakpoint to be set." :group 'jde-project :type '(cons :tag "Colors" (string :tag "Foreground") (string :tag "Background")) :set '(lambda (sym val) (make-face 'jde-db-spec-breakpoint-face) (set-face-foreground 'jde-db-spec-breakpoint-face (car val)) (set-face-background 'jde-db-spec-breakpoint-face (cdr val)) (set-default sym val)))

(defcustom jde-db-requested-breakpoint-face-colors (cons "black" "yellow") "\
*Specifies the foreground and background colors used to highlight
the line at which you have requested a breakpoint to be set." :group 'jde-project :type '(cons :tag "Colors" (string :tag "Foreground") (string :tag "Background")) :set '(lambda (sym val) (make-face 'jde-db-requested-breakpoint-face) (set-face-foreground 'jde-db-requested-breakpoint-face (car val)) (set-face-background 'jde-db-requested-breakpoint-face (cdr val)) (set-default sym val)))

(defcustom jde-db-active-breakpoint-face-colors (cons "black" "red") "\
*Specifies the foreground and background colors used to highlight
a line where an active breakpoint exists." :group 'jde-project :type '(cons :tag "Colors" (string :tag "Foreground") (string :tag "Background")) :set '(lambda (sym val) (make-face 'jde-db-active-breakpoint-face) (set-face-foreground 'jde-db-active-breakpoint-face (car val)) (set-face-background 'jde-db-active-breakpoint-face (cdr val)) (set-default sym val)))

;;;***

;;;### (autoloads (jde-bug-sio-connect-delay) "jde-dbs" "lisp/jde-dbs.el")
(defconst custom-define-current-source-file "jde-dbs.el")

(defcustom jde-bug-sio-connect-delay 1 "\
Length of time in seconds that the JDE waits
before attempting to connect to the   
debuggee application's standard I/O. This delay
is intended to give JDEbug time to create the
SIO socket. Try increasing this variable if JDEbug
hangs while launching an application. If your
system never hangs, you can reduce this setting
to 0 to eliminate the connection delay." :group 'jde-bug :type 'integer)

;;;***

;;;### (autoloads (jde-ejb-entity-descriptor-buffer-template jde-ejb-session-descriptor-buffer-template jde-ejb-session-bean-template jde-ejb-entitiy-bean-template jde-ejb-local-home-buffer-template jde-ejb-local-buffer-template jde-ejb-home-buffer-template jde-ejb-remote-buffer-template jde-ejb-descriptor-format jde-ejb-class-format jde-ejb-local-home-format jde-ejb-local-format jde-ejb-home-format jde-ejb-remote-format jde-ejb) "jde-ejb" "lisp/jde-ejb.el")
(defconst custom-define-current-source-file "jde-ejb.el")

(defgroup jde-ejb nil "JDE EJB Electric Class Builder" :group 'jde :prefix "jde-ejb-")

(defcustom jde-ejb-remote-format "%s.java" "\
*Default format for EJB Remote Interface" :type 'string :group 'jde-ejb)

(defcustom jde-ejb-home-format "%sHome.java" "\
*Default format for EJB Home Interface
Setting this also resets jde-ejb-home to the
name portion of the filename string." :type 'string :group 'jde-ejb :set '(lambda (sym val) (set-default 'jde-ejb-home (file-name-sans-extension val)) (set-default sym val)))

(defcustom jde-ejb-local-format "%sLocal.java" "\
*Default format for EJB Local Interface" :type 'string :group 'jde-ejb :set '(lambda (sym val) (set-default 'jde-ejb-local (file-name-sans-extension val)) (set-default sym val)))

(defcustom jde-ejb-local-home-format "%sLocalHome.java" "\
*Default format for EJB LocalHome Interface
Setting this also resets jde-ejb-local-home to the
name portion of the filename string." :type 'string :group 'jde-ejb :set '(lambda (sym val) (set-default 'jde-ejb-local-home (file-name-sans-extension val)) (set-default sym val)))

(defcustom jde-ejb-class-format "%sBean.java" "\
*Default format for EJB Class.
Setting this also resets jde-ejb-class to the
name portion of the filename string." :type 'string :group 'jde-ejb :set '(lambda (sym val) (set-default 'jde-ejb-class (file-name-sans-extension val)) (set-default sym val)))

(defcustom jde-ejb-descriptor-format "%sEJB.xml" "\
*Default format for EJB Deployment Descriptor" :type 'string :group 'jde-ejb)

(defcustom jde-ejb-remote-buffer-template (list "(funcall jde-gen-boilerplate-function)" "jde-ejb-package '>'n" "'>'n" "\"public interface \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" extends javax.ejb.EJBObject \"" "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n" "'>'n" "\"}\">" "\" // \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new EJB Remote interface.
This is the interface that contains all user methods.
Setting this variable defines a template instantiation
command `jde-ejb-remote', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-remote (tempo-define-template "java-ejb-remote-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java class buffer skeleton.")) (set-default sym val)))

(defcustom jde-ejb-home-buffer-template (list "(funcall jde-gen-boilerplate-function)" "jde-ejb-package '>'n" "'>'n" "\"public interface \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" extends javax.ejb.EJBHome \"" "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n" "'>'n" "\"}\">" "\" // \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new EJB Home interface.
This interface defines the create/find (for entity beans)/remove
methods. Setting this variable defines a template instantiation
command `jde-ejb-home', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-home (tempo-define-template "java-ejb-home-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java class buffer skeleton.")) (set-default sym val)))

(defcustom jde-ejb-local-buffer-template (list "(funcall jde-gen-boilerplate-function)" "jde-ejb-package '>'n" "'>'n" "\"public interface \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" extends javax.ejb.EJBLocalObject \"" "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n" "'>'n" "\"}\">" "\" // \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new EJB Local interface.
This is the interface that contains all user methods.
Setting this variable defines a template instantiation
command `jde-ejb-local', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-local (tempo-define-template "java-ejb-local-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java class buffer skeleton.")) (set-default sym val)))

(defcustom jde-ejb-local-home-buffer-template (list "(funcall jde-gen-boilerplate-function)" "jde-ejb-package '>'n" "'>'n" "\"public interface \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" extends javax.ejb.EJBLocalHome \"" "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n" "'>'n" "\"}\">" "\" // \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new EJB LocalHome interface.
This interface defines the create/find (for entity beans)/remove
methods. Setting this variable defines a template instantiation
command `jde-ejb-local-home', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-local-home (tempo-define-template "java-ejb-local-home-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java class buffer skeleton.")) (set-default sym val)))

(defcustom jde-ejb-entitiy-bean-template (list "(funcall jde-gen-boilerplate-function)" "jde-ejb-package '>'n" "'>" "'>'n" "\"public class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" " \" implements EntityBean \" " "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n'n" "'>'p'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbCreate\"" "  nil" "  \"CreateException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "   \"public\"" "  \"void\"" "  \"ejbActivate\"" "  nil" "  nil" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbPassivate\"" "  nil" "  nil" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbLoad\"" "  nil" "  nil" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbStore\"" "  nil" "  nil" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbRemove\"" "  nil" "  \"RemoveException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"setEntityContext\"" "  \"EntityContext ctx\"" "  nil" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"unsetEntityContext\"" "  nil" "  nil" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n '>" "\"}\">" "\" // \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new Entity Bean class.
Entity beans must have  a Find method using a primary key.
The method is defined in the Home interface and implemented
here under a slightly different name (see EJB specifications for details.
Similarly, any create methods defined in the Home interface
will also be instantiated here, but under a slightly different name.
Setting this variable defines a template instantiation
command `jde-ejb-entity-bean', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-entity-bean (tempo-define-template "java-ejb-entity-bean-template" (jde-gen-read-template val) nil "Insert a generic Entity Bean skeleton.")) (set-default sym val)))

(defcustom jde-ejb-session-bean-template (list "(funcall jde-gen-boilerplate-function)" "jde-ejb-package '>'n" "'>" "'>'n" "\"public class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" " \" implements SessionBean \" " "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n'n" "'>'p'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbCreate\"" "  nil" "  \"CreateException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbActivate\"" "  nil" "  nil" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbPassivate\"" "  nil" "  nil" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbRemove\"" "  nil" "  nil" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"setSessionContext\"" "  \"SessionContext ctx\"" "  nil" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "\"}\">" "\" // \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new Session Bean class.
This creates the class for a session bean.  It includes the
necessary interface implementations.
Setting this variable defines a template instantiation
command `jde-ejb-session-bean', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-session-bean (tempo-define-template "java-ejb-session-bean-template" (jde-gen-read-template val) nil "Insert a generic Session Bean skeleton.")) (set-default sym val)))

(defcustom jde-ejb-session-descriptor-buffer-template (list "\"<?xml version=\\\"1.0\\\"?>\"'n" "\"<!DOCTYPE ejb-jar PUBLIC \\\"-//Sun Microsystems, Inc.//DTD Enterprise JavaBeans 2.0//EN\\\" \" " "\" \\\"http://java.sun.com/dtd/ejb-jar_2_0.dtd\\\" > \"'>'n'n" "\"<ejb-jar>\"'>'n" "\"<enterprise-beans>\" '>'n" "\"<session> \"'>'n" "\"<ejb-name>\"" "(format jde-ejb-class  jde-current-ejb-name)" "\"</ejb-name>\"'>'n" "\"<home>\"" "(format (concat \"%s.\" jde-ejb-home) jde-current-ejb-package jde-current-ejb-name)" "\"</home>\"'>'n" "\"<remote>\"" "(format \"%s.%s\" jde-current-ejb-package jde-current-ejb-name)" "\"</remote>\"'>'n" "\"<local-home>\"" "(format (concat \"%s.\" jde-ejb-local-home) jde-current-ejb-package jde-current-ejb-name)" "\"</local-home>\"'>'n" "\"<local>\"" "(format (concat \"%s.\" jde-ejb-local) jde-current-ejb-package jde-current-ejb-name)" "\"</local>\"'>'n" "\"<ejb-class>\"" "(format \"%s.%s\" jde-current-ejb-package (format jde-ejb-class  jde-current-ejb-name))" "\"</ejb-class>\"'>'n" "\"<session-type>Stateless</session-type>\"'>'n" "\"<transaction-type>Container</transaction-type>\"'>'n" "\"</session>\"'>'n" "\"</enterprise-beans>\"'>'n" "\"<ejb-client-jar>\"" "(format \"%sClient.jar\" jde-current-ejb-name )" "\"</ejb-client-jar>\"'>'n" "\"</ejb-jar>\"'>'n" "'>'n") "\
*Template for new EJB Session Bean Deployment Descriptor interface.
This template uses internal functions to get the package and ejb names
interpolated when the XML file is generated from the template.
Setting this variable defines a template instantiation
command `jde-ejb-session-descriptor', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-session-descriptor (tempo-define-template "java-ejb-session-descriptor-buffer-template" (jde-gen-read-template val) nil "Insert a generic XML Deployment Descriptor buffer skeleton.")) (set-default sym val)))

(defcustom jde-ejb-entity-descriptor-buffer-template (list "\"<?xml version=\\\"1.0\\\"?>\"'n" "\"<!DOCTYPE ejb-jar PUBLIC \\\"-//Sun Microsystems, Inc.//DTD Enterprise JavaBeans 2.0//EN\\\" \" " "\" \\\"http://java.sun.com/dtd/ejb-jar_2_0.dtd\\\" > \"'>'n'n" "\"<ejb-jar>\"'>'n" "\"<enterprise-beans>\" '>'n" "\"<entity> \"'>'n" "\"<ejb-name>\"" "(format jde-ejb-class  jde-current-ejb-name)" "\"</ejb-name>\"'>'n" "\"<home>\"" "(format (concat \"%s.\" jde-ejb-home) jde-current-ejb-package jde-current-ejb-name)" "\"</home>\"'>'n" "\"<remote>\"" "(format \"%s.%s\" jde-current-ejb-package jde-current-ejb-name)" "\"</remote>\"'>'n" "\"<local-home>\"" "(format (concat \"%s.\" jde-ejb-local-home) jde-current-ejb-package jde-current-ejb-name)" "\"</local-home>\"'>'n" "\"<local>\"" "(format (concat \"%s.\" jde-ejb-local) jde-current-ejb-package jde-current-ejb-name)" "\"</local>\"'>'n" "\"<ejb-class>\"" "(format \"%s.%s\" jde-current-ejb-package (format jde-ejb-class  jde-current-ejb-name))" "\"</ejb-class>\"'>'n" "\"<persistence-type>Container</persistence-type>\"'>'n" "\"<prim-key-class>\"" "(format \"%s.%sPK\" jde-current-ejb-package jde-current-ejb-name)" "\"</prim-key-class>\"'>'n" "\"<reentrant>False</reentrant>\"'>'n" "\"</entity>\"'>'n" "\"</enterprise-beans>\"'>'n" "\"<assembly-descriptor>\"'>'n" "\"<container-transaction>\"'>'n" "\"<method>\"'>'n" "\"<ejb-name>\"" "(format jde-ejb-class  jde-current-ejb-name)" "\"</ejb-name>\"'>'n" "\"<method-intf>Local</method-intf>\"'>'n" "\"<method-name>*</method-name>\"'>'n" "\"</method>\"'>'n" "\"<method>\"'>'n" "\"<ejb-name>\"" "(format jde-ejb-class  jde-current-ejb-name)" "\"</ejb-name>\"'>'n" "\"<method-intf>Remote</method-intf>\"'>'n" "\"<method-name>*</method-name>\"'>'n" "\"</method>\"'>'n" "\"<trans-attribute>Required</trans-attribute>\"'>'n" "\"</container-transaction>\"'>'n" "\"</assembly-descriptor>\"'>'n" "\"</ejb-jar>\"'>'n" "'>'n") "\
*Template for new EJB Entity Bean Deployment Descriptor interface.
This template uses internal functions to get the package and ejb names
interpolated when the XML file is generated from the template.
Setting this variable defines a template instantiation
command `jde-ejb-session-descriptor', as a side-effect." :group 'jde-ejb :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-ejb-entity-descriptor (tempo-define-template "java-ejb-entity-descriptor-buffer-template" (jde-gen-read-template val) nil "Insert a generic XML Deployment Descriptor buffer skeleton.")) (set-default sym val)))

;;;***

;;;### (autoloads (jde-newline-function jde-electric-return-p jde-gen-cflow-finally jde-gen-cflow-try-finally jde-gen-cflow-catch jde-gen-cflow-try-catch jde-gen-cflow-case jde-gen-cflow-switch jde-gen-cflow-for-iter jde-gen-cflow-for-i jde-gen-cflow-for jde-gen-cflow-while jde-gen-cflow-else-if jde-gen-cflow-if-else jde-gen-cflow-else jde-gen-cflow-if jde-gen-comments jde-gen-cflow-enable jde-gen-code-templates jde-gen-exception-buffer-template jde-gen-tostring-method-template jde-gen-hashcode-method-template jde-gen-equals-method-template jde-gen-equals-parens-around-expression jde-gen-equals-trailing-and-operators jde-gen-method-template jde-gen-method-javadoc-comment jde-gen-session-bean-template jde-gen-entity-bean-template jde-gen-event-source-fire-method-template jde-gen-listener-registry jde-gen-property-change-support jde-gen-beep jde-gen-println jde-gen-main-method-template jde-gen-change-listener-template jde-gen-mouse-motion-listener-template jde-gen-mouse-listener-template jde-gen-window-listener-template jde-gen-action-listener-template jde-gen-inner-class-template jde-gen-section-comment-template jde-gen-buffer-templates jde-gen-jfc-app-buffer-template jde-gen-bean-template jde-gen-get-set-var-template jde-gen-deep-clone-template jde-gen-console-buffer-template jde-gen-interface-buffer-template jde-gen-class-buffer-template jde-gen-conditional-padding-3 jde-gen-conditional-padding-2 jde-gen-conditional-padding-1 jde-gen-method-signature-padding-3 jde-gen-method-signature-padding-2 jde-gen-method-signature-padding-1 jde-gen-final-methods jde-gen-final-arguments jde-gen-boilerplate-function jde-gen-buffer-boilerplate jde-gen-k&r jde-gen) "jde-gen" "lisp/jde-gen.el")
(defconst custom-define-current-source-file "jde-gen.el")

(defgroup jde-gen nil "JDE Autocoder" :group 'jde :prefix "jde-gen-")

(defcustom jde-gen-k&r t "\
*If non-nil, use braces in Original Kernighan & Ritchie Style.
The Creators of C started using brace placement style:

    class Some {

    }

But there is also the alternative line-up style:

    class Some
    {

    }

Setting this variable to t, uses K&R style in skeletons and tempaltes.

Note: According to the Java Code Convention [section 6.4], this value should
      be non-nil." :group 'jde-gen :type 'boolean)

(defcustom jde-gen-buffer-boilerplate nil "\
*Lines of boilerplate text to put at the head of a buffer template." :group 'jde-gen :type '(repeat (string :tag "Line")))

(defcustom jde-gen-boilerplate-function 'jde-gen-create-buffer-boilerplate "\
*Specifes buffer boilerplate text function.
This variable specifies a function to create boilerplate text for
insertion at the head of Java source buffers generated by JDE
templates. The specified function should take no arguments and should
return a text string.  The default value is
`jde-gen-create-buffer-boilerplate', which returns the lines of text
specified by `jde-gen-buffer-boilerplate'." :group 'jde-gen :type 'function)

(defcustom jde-gen-final-arguments t "\
Specifies whether to add final modifiers to method arguments.
If this variable is t, `jde-gen-method-signature' automatically
adds final modifiers to each method argument." :group 'jde-gen :type 'boolean)

(defcustom jde-gen-final-methods t "\
Specifies whether to add final method modifier.
If this variable is t, `jde-gen-method-signature' automatically adds
the final method modifier. This option is ignored within final classes.
Note that anonymous classes are implicitly final." :group 'jde-gen :type 'boolean)

(defcustom jde-gen-method-signature-padding-1 "" "\
String that comes just after the function name and just before
the opening parenthesis of the argument list for a method call or definition.
For example, if set to a single space [\" \"], then a generated method might
look like:

    void setXxxx () {
                ^
If not set, the same generated method would look like:

    void setXxxx() {
                ^
Note: According to the Java Code Convention [section 6.4], this value should
      be the empty string." :group 'jde-gen :type 'string)

(defcustom jde-gen-method-signature-padding-2 "" "\
String which comes just after the opening parenthesis and just before
the closing parenthesis of an argument list for a method call or definition.
For example, if set to a single space [\" \"], then a generated method might
look like:

    void setXxxx( boolean newValue ) {
                 ^                ^
If not set, the same generated method would look like:

    void setXxxx(boolean newValue) {
                 ^              ^
Note: According to the Java Code Convention [section 6.4], this value should
      be the empty string." :group 'jde-gen :type 'string)

(defcustom jde-gen-method-signature-padding-3 " " "\
String which comes just after the closing parenthesis of an
argument list for a method call or definition.  For example, if set to
a single space [\" \"], then a generated method might look like:

    void setXxxx(boolean newValue) {
                                  ^
If not set, the same generated method would look like:

    void setXxxx(boolean newValue){
                                  ^
Note: According to the Java Code Convention [section 6.4], this value should
      be a single space." :group 'jde-gen :type 'string)

(defcustom jde-gen-conditional-padding-1 " " "\
The string to be inserted between a conditional keyword (if, while, etc.)
and the opening parenthesis for its conditional expression:

    <keyword><1>(<2><expression><2>)<3>{

also:  <3>else<3>{

where <1> is jde-gen-conditional-padding-1
  and <2> is jde-gen-conditional-padding-2
  and <3> is jde-gen-conditional-padding-3.

For example, if <1> is a space, <2> is nil and <3> is a space, then a while
clause might look like:

    while (true) {

Note: According to the Java Code Convention [section 7.4], this value should
      be a single space." :group 'jde-gen :type 'string)

(defcustom jde-gen-conditional-padding-2 "" "\
The string to be inserted before and after a conditional expression
between the parentheses.  See `jde-gen-conditional-padding-1' for details.

Note: According to the Java Code Convention [section 7.4], this value should
      be the empty string." :group 'jde-gen :type 'string)

(defcustom jde-gen-conditional-padding-3 " " "\
The string to be inserted after the closing parenthesis of the
conditional expression and before the opening brace.  See
`jde-gen-conditional-padding-1' for details.

Note: According to the Java Code Convention [section 7.4], this value should
      be a single space." :group 'jde-gen :type 'string)

(defcustom jde-gen-class-buffer-template (list "(funcall jde-gen-boilerplate-function)" "(jde-gen-get-package-statement)" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\" * Describe class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" here.\" 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert-empty-line)" "\" * Created: \" (current-time-string) 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-author-tag))" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-version-tag))" "\" \" (jde-javadoc-insert-end-block)" "\"public class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" \" (jde-gen-get-extend-class)" "(jde-gen-electric-brace)" "'p'n" "\"}\">" "(if jde-gen-comments (concat \" // \"" "  (file-name-sans-extension (file-name-nondirectory buffer-file-name))))" "'>'n" ";; Here comes the stuff that needs a fully generated class." ";; We jump back and add those things retrospectively." "(progn (tempo-backward-mark)" " (jde-gen-save-excursion" "  (jde-gen-get-interface-implementation t))" " (jde-gen-save-excursion" "  (jde-wiz-gen-method \"public\" \"\"" "   (file-name-sans-extension (file-name-nondirectory buffer-file-name)) \"\" \"\" \"\")))" ";; Move to constructor body. Set tempo-marks to nil in order to prevent tempo moving to mark." "(progn (re-search-forward \"^[ \\t]*$\") (setq tempo-marks nil) nil)") "\
*Template for new Java class.
Setting this variable defines a template instantiation
command `jde-gen-class', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (tempo-define-template "java-class-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java class buffer skeleton.") (defalias 'jde-gen-class (list 'lambda (list) (list 'interactive) (list 'tempo-template-java-class-buffer-template) (list 'jde-gen-insert-interface-implementation))) (set-default sym val)))

(defcustom jde-gen-interface-buffer-template (list "(funcall jde-gen-boilerplate-function)" "(jde-gen-get-package-statement)" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\" * Describe interface \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" here.\" 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert-empty-line)" "\" * Created: \" (current-time-string) 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-author-tag))" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-version-tag))" "\" \" (jde-javadoc-insert-end-block)" "\"public interface \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" \" (jde-gen-get-extend-class)" "(jde-gen-electric-brace)" "'p'n" "\"}\">" "(if jde-gen-comments (concat \" // \"" "  (file-name-sans-extension (file-name-nondirectory buffer-file-name))))" "'>'n") "\
*Template for new Java interface.
Setting this variable defines a template instantiation
command `jde-gen-interface', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (tempo-define-template "java-interface-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java interface buffer skeleton.") (defalias 'jde-gen-interface (list 'lambda (list) (list 'interactive) (list 'tempo-template-java-interface-buffer-template))) (set-default sym val)))

(defcustom jde-gen-console-buffer-template (list "(funcall jde-gen-boilerplate-function)" "(jde-gen-get-package-statement)" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\" * Describe class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" here.\" 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert-empty-line)" "\" * Created: \" (current-time-string) 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-author-tag))" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-version-tag))" "\" \" (jde-javadoc-insert-end-block)" "\"public final class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "(jde-gen-electric-brace \" \")" "'p'n" "\"}\">" "(if jde-gen-comments (concat \" // \"" "  (file-name-sans-extension (file-name-nondirectory buffer-file-name))))" "'>'n" ";; Here comes the stuff that needs a fully generated class." ";; We jump back and add those things retrospectively." "(progn (tempo-backward-mark)" " (jde-gen-save-excursion" "  (jde-gen-main-method))" " (tempo-backward-mark)" " (jde-gen-save-excursion" "  (jde-wiz-gen-method \"private\" \"\"" "   (file-name-sans-extension (file-name-nondirectory buffer-file-name)) \"\" \"\" \"\")))" ";; Move to constructor body. Set tempo-marks to nil in order to prevent tempo moving to mark." "(progn (re-search-forward \"^[ \\t]*$\") (setq tempo-marks nil) nil)") "\
*Template for new Java console app main class buffer.
Setting this variable defines a template instantiation
command `jde-gen-console', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-console (tempo-define-template "java-console-buffer-template" (jde-gen-read-template val) nil "Insert skeleton for a new Java console buffer")) (set-default sym val)))

(defcustom jde-gen-deep-clone-template '("(jde-wiz-generate-interface \"java.lang.Cloneable\")" "'&'> (progn (require 'jde-javadoc) nil)" "(jde-javadoc-insert-start-block)" "\"* Create a deep clone of this object.\" '>'n" "\"*\" '>'n" "\"* @return a deep clone of this object.\" '>'n" "'> (jde-javadoc-insert-end-block)" "(let (jde-gen-final-methods)" " (jde-gen-method-signature" "   \"public\"" "   \"Object\"" "   \"clone\"" "   nil" " ))" "'>" "(jde-gen-electric-brace)" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" ret = null;\" '>'n'n" "(let ((beg (point)))" "  (insert \"ret = (\")" "  (insert (file-name-sans-extension" "    (file-name-nondirectory buffer-file-name)))" "  (insert \") super.clone();\")" "  (jde-gen-try-catch-wrapper beg (point))" "  (insert \"CloneNotSupportedException\")" "  nil)" "(progn" " (goto-char (scan-lists (point) 1 1))" " (goto-char (scan-lists (point) 1 -1))" " (end-of-line)" " 'n)" "\"throw new InternalError(\\\"clone should be supported (forgot?)\\\");\"" "'>'%" "(progn (goto-char (scan-lists (point) 1 1)) (end-of-line) '(l n))" "(if jde-gen-comments " " '(l \" // add non-immutable member clone assignments here\" '>'n))" "'p'n" "\"return ret;\" '>'n" "\"}\" '>'n") "\
*Template for creating a deep clone method.
Setting this variable defines a template instantiation
command `jde-gen-deep-clone', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-deep-clone (tempo-define-template "java-deep-clone-method" (jde-gen-read-template val) nil "Create a deep clone method at the current point.")) (set-default sym val)))

(defcustom jde-gen-get-set-var-template '("(jde-gen-insert-at-class-top nil t)" "(progn (tempo-save-named 'mypos (point-marker)) nil)" "(progn" "  (jde-gen-get-next-member-pos '(\"private\")) nil)" "(P \"Variable type: \" type t)" "(P \"Variable name: \" name t)" "'&'n'>" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\"* Describe \" (s name) \" here.\" '>'n" "'> (jde-javadoc-insert-end-block)" "'& \"private \" (s type) \" \"" "(s name) \";\" '>" "(progn (goto-char (marker-position (tempo-lookup-named 'mypos))) nil)" "(jde-gen-blank-lines 2 -1)" "'> (jde-javadoc-insert-start-block)" "\"* Get the <code>\" (jde-gen-lookup-and-capitalize 'name) \"</code> value.\" '>'n" "'> (jde-javadoc-insert-empty-line)" "'>" "(let ((type (tempo-lookup-named 'type)))" "  (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-return-tag)))" "'> (jde-javadoc-insert-end-block)" "(jde-gen-method-signature" "  \"public\"" "  (jde-gen-lookup-named 'type)" "  (if (string= \"boolean\" (jde-gen-lookup-named 'type) ) " "    (concat \"is\" (jde-gen-lookup-and-capitalize 'name))" "   (concat \"get\" (jde-gen-lookup-and-capitalize 'name)))" "  nil" " )" "(jde-gen-electric-brace)" "\"return \" (s name) \";\" '>'n \"}\"'>'n" "'n" "'> (jde-javadoc-insert-start-block)" "\"* Set the <code>\" (jde-gen-lookup-and-capitalize 'name) \"</code> value.\" '>'n" "\"*\" '>'n" "\"* @param new\" (jde-gen-lookup-and-capitalize 'name)" "\" The new \" (jde-gen-lookup-and-capitalize 'name) \" value.\" '>'n" "'> (jde-javadoc-insert-end-block)" "(jde-gen-method-signature " "  \"public\"" "  \"void\"" "  (concat \"set\" (jde-gen-lookup-and-capitalize 'name))" "  (concat (jde-gen-lookup-named 'type) \" new\" " "          (jde-gen-lookup-and-capitalize 'name))" " )" "(jde-gen-electric-brace)" "'>\"this.\" (s name) \" = new\" (jde-gen-lookup-and-capitalize 'name)" "\";\" '>'n \"}\" '>" "(when (looking-at \"\\\\s-*\\n\\\\s-*$\")" "  (forward-line 1) (end-of-line) nil)") "\
*Template for creating a variable at the top of the class and
a get/set method pair for the variable at point.
Setting this variable defines a template instantiation
command `jde-gen-get-set', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-get-set (tempo-define-template "java-get-set-pair" (jde-gen-read-template val) nil "Insert variable at the top of the class and get-set method pair at point.")) (set-default sym val)))

(defcustom jde-gen-bean-template '(";; generate class and save point which is in body of the constructor" "(jde-gen-class) 'p" "(progn (end-of-buffer) (search-backward \"}\") (backward-char 1)) 'n" "(jde-gen-blank-lines 2 -1)" "(jde-gen-save-excursion" " (jde-wiz-generate-interface \"java.io.Serializable\")" " (jde-import-insert-import '(\"java.io.Serializable\"))" " (call-interactively 'jde-gen-get-set-methods))") "\
*Template for creating a Java bean.
Setting this variable defines a template instantiation
command `jde-gen-bean', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-bean (tempo-define-template "java-bean-template" (jde-gen-read-template val) nil "Create a Java bean.")) (set-default sym val)))

(defcustom jde-gen-jfc-app-buffer-template (list "(funcall jde-gen-boilerplate-function)" "(jde-gen-get-package-statement)" "\"import java.awt.Dimension;\" '>'n" "\"import java.awt.Graphics;\" '>'n" "\"import java.awt.Graphics2D;\" '>'n" "\"import java.awt.Color;\" '>'n" "\"import java.awt.geom.Ellipse2D;\" '>'n" "\"import java.awt.event.WindowAdapter;\" '>'n" "\"import java.awt.event.WindowEvent;\" '>'n" "\"import javax.swing.JFrame;\" '>'n" "\"import javax.swing.JPanel;\" '>'n" "\"import javax.swing.JScrollPane;\" '>'n" "\"import javax.swing.JMenuBar;\" '>'n" "\"import javax.swing.JMenu;\" '>'n" "\"import java.awt.event.ActionEvent;\" '>'n" "\"import javax.swing.AbstractAction;\" '>'n '>'n" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\" * \"" "(file-name-nondirectory buffer-file-name) '>'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert-empty-line)" "\" * Created: \" (current-time-string) '>'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert 'tempo-template-jde-javadoc-author-tag)" "\" \" (jde-javadoc-insert 'tempo-template-jde-javadoc-version-tag)" "\" \" (jde-javadoc-insert 'tempo-template-jde-javadoc-end-block \"*/\")" "'>'n" "\"public class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" extends JFrame\"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"class Canvas extends JPanel\"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"\"" "  \"Canvas\"" "  \"\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"setSize(getPreferredSize());\" '>'n" "\"Canvas.this.setBackground(Color.white);\" '>'n" "\"}\"'>'n '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"Dimension\"" "  \"getPreferredSize\"" "  \"\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"return new Dimension(600, 600);\" '>'n" "\"}\"'>'n '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"paintComponent\"" "  \"Graphics g\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"super.paintComponent(g);\" '>'n" "\"Graphics2D g2d = (Graphics2D) g;\" '>'n" "\"Ellipse2D circle = new Ellipse2D.Double(0d, 0d, 100d, 100d);\" '>'n" "\"g2d.setColor(Color.red);\" '>'n" "\"g2d.translate(10, 10);\" '>'n" "\"g2d.draw(circle);\" '>'n" "\"g2d.fill(circle);\" '>'n" "\"}\"'>'n " "\"}\"'>'n '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"\"" "  (file-name-sans-extension (file-name-nondirectory buffer-file-name))" "  \"\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"super(\\\"\" (P \"Enter app title: \") \"\\\");\" '>'n" "\"setSize(300, 300);\" '>'n" "\"addWindowListener(new WindowAdapter() \"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"public void windowClosing(WindowEvent e) {System.exit(0);}\" '>'n" "\"public void windowOpened(WindowEvent e) {}\" '>'n" "\"});\"'>'n" "\"setJMenuBar(createMenu());\" '>'n" "\"getContentPane().add(new JScrollPane(new Canvas()));\" '>'n" "\"}\"'>'n" "'>'n" "(jde-gen-method-signature" "   \"public static\"" "   \"void\"" "   \"main\"" "   \"String[] args\"" " )" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "'>'n" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" f = new \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\"();\" '>'n" "\"f.show();\" '>'n" "\"}\"'>'n '>'n" "\"protected JMenuBar createMenu() \"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"JMenuBar mb = new JMenuBar();\" '>'n" "\"JMenu menu = new JMenu(\\\"File\\\");\" '>'n" "\"menu.add(new AbstractAction(\\\"Exit\\\") \"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"actionPerformed\"" "  \"ActionEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"System.exit(0);\" '>'n" "\"}\" '>'n" "\"});\" '>'n" "\"mb.add(menu);\" '>'n" "\"return mb;\" '>'n" "\"}\"'>'n " "\"} // \"'>" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for JFC (Swing) application buffer.
Setting this variable defines a template instantiation
command `jde-gen-jfc-app', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-jfc-app (tempo-define-template "java-jfc-app-buffer-template" (jde-gen-read-template val) nil "Insert skeleton for a JFC app buffer")) (set-default sym val)))

(defcustom jde-gen-buffer-templates (list (cons "Class" 'jde-gen-class) (cons "Interface" 'jde-gen-interface) (cons "Exception Class" 'jde-gen-exception) (cons "Console" 'jde-gen-console) (cons "Swing App" 'jde-gen-jfc-app) (cons "Unit Test" 'jde-junit-test-class)) "\
*Specifies available autocode templates for creating buffers.
The value of this variable is an association list. The car of
each element specifies the template's title. The cdr specifies
a command that inserts the template into a buffer. See the function
`tempo-define-template' for any easy way to create a template
insertion command." :group 'jde-gen :type '(repeat (cons :tag "Template" (string :tag "Title") (function :tag "Command"))) :set '(lambda (sym val) (let ((n (length val)) (i 0)) (setq jde-gen-buffer-template-names (list)) (while (< i n) (setq jde-gen-buffer-template-names (append jde-gen-buffer-template-names (list (cons (car (nth i val)) (1+ i))))) (setq i (1+ i)))) (set-default sym val)))

(defcustom jde-gen-section-comment-template '("(p \"Comment: \" comment-line 'noinsert)" "'n" "\"// \" (s comment-line) '>'n'n'>") "\
*Template for generating a section comment. Used as an introductory
comment to a source code section by code generating functions." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-section-comment (tempo-define-template "section comment" (jde-gen-read-template val) nil "Insert section comment.")) (set-default sym val)))

(defcustom jde-gen-inner-class-template '("(end-of-line) '& \"class \" (P \"Class name: \" class) '>" "\" \" (jde-gen-get-extend-class)" "(if jde-gen-k&r " " ()" " '>'n)" "\"{\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  nil" "  (jde-gen-lookup-named 'class)" "  nil" " )" "(if jde-gen-k&r " " ()" " '>'n)" "\"{\"'>'n" "\"}\"'>'n" "'>'n" "(jde-gen-get-interface-implementation)" "'>'n" "\"}\" '>'n'>") "\
*Template that creates an empty private class at point." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (tempo-define-template "java-inner-class" (jde-gen-read-template val) nil "Insert inner class.") (defalias 'jde-gen-inner-class-internal (list 'lambda (list) (list 'tempo-template-java-inner-class) (list 'jde-gen-insert-interface-implementation))) (set-default sym val)))

(defcustom jde-gen-action-listener-template '("'& (P \"Component name: \")" "\".addActionListener(\" jde-gen-method-signature-padding-2 " "\"new ActionListener\" jde-gen-method-signature-padding-1 \"()\" '>" "(if jde-gen-k&r " " jde-gen-method-signature-padding-3" " 'n)" "\"{\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"actionPerformed\"" "  \"ActionEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "\"}\" jde-gen-method-signature-padding-2 \");\"'>'n'>'n'>") "\
*Template for generating an action listener.
Setting this variable defines a template instantiation
command, `jde-gen-action-listener', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-action-listener (tempo-define-template "java-action-listener" (jde-gen-read-template val) nil "Insert skeleton action listener.")) (set-default sym val)))

(defcustom jde-gen-window-listener-template '("(end-of-line) '& (P \"Window name: \")" "\".addWindowListener(\" jde-gen-method-signature-padding-2 " "\"new WindowAdapter\" jde-gen-method-signature-padding-1 \"()\"'>" "(if jde-gen-k&r " " jde-gen-method-signature-padding-3" " 'n)" "\"{\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowActivated\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowClosed\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowClosing\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" " \"System.exit(0);\" '>'n \"}\"" "'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowDeactivated\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowDeiconified\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowIconified\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"windowOpened\"" "  \"WindowEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "\"}\" jde-gen-method-signature-padding-2 \");\" '>'n'>") "\
*Template for generating a window listener.
Setting this variable defines a template instantiation
command, `jde-gen-window-listener', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-window-listener (tempo-define-template "java-window-listener" (jde-gen-read-template val) nil "Insert skeleton window listener.")) (set-default sym val)))

(defcustom jde-gen-mouse-listener-template '("(end-of-line) '& (P \"Component name: \")" "\".addMouseListener(\" jde-gen-method-signature-padding-2 " "\"new MouseAdapter\" jde-gen-method-signature-padding-1 \"()\" '>" "(if jde-gen-k&r " " jde-gen-method-signature-padding-3" " 'n)" "\"{\"'>'n " "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mouseClicked\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mouseEntered\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mouseExited\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mousePressed\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mouseReleased\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "\"}\" jde-gen-method-signature-padding-2 \");\"'>'n'>") "\
*Template for generating a mouse listener.
Setting this variable defines a template instantiation
command, `jde-gen-mouse-listener', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-mouse-listener (tempo-define-template "java-mouse-listener" (jde-gen-read-template val) nil "Insert skeleton mouse listener.")) (set-default sym val)))

(defcustom jde-gen-mouse-motion-listener-template '("(end-of-line) '& (P \"Component name: \")" "\".addMouseMotionListener(\" jde-gen-method-signature-padding-2 " "\"new MouseMotionAdapter\" jde-gen-method-signature-padding-1 \"()\" '>" "(if jde-gen-k&r " " jde-gen-method-signature-padding-3" " 'n)" "\"{\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mouseDragged\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"mouseMoved\"" "  \"MouseEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "\"}\" jde-gen-method-signature-padding-2 \");\"'>'n'>") "\
*Template for generating a mouse listener.
Setting this variable defines a template instantiation
command, `jde-gen-mouse-motion-listener', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-mouse-motion-listener (tempo-define-template "java-mouse-motion-listener" (jde-gen-read-template val) nil "Insert skeleton mouse motion listener.")) (set-default sym val)))

(defcustom jde-gen-change-listener-template '("'& (P \"Component name: \")" "\".addChangeListener(\" jde-gen-method-signature-padding-2 " "\"new ChangeListener\" jde-gen-method-signature-padding-1 \"()\" '>" "(if jde-gen-k&r " " jde-gen-method-signature-padding-3" " 'n)" "\"{\"'>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"stateChanged\"" "  \"ChangeEvent e\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n" "\"}\" jde-gen-method-signature-padding-2 \");\"'>'n'>'n'>") "\
*Template for generating a change listener.
Setting this variable defines a template instantiation
command, `jde-gen-change-listener', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-change-listener (tempo-define-template "java-change-listener" (jde-gen-read-template val) nil "Insert skeleton change listener.")) (set-default sym val)))

(defcustom jde-gen-main-method-template '("(jde-gen-save-excursion" " (jde-wiz-gen-method" "   \"public static\"" "   \"void\"" "   \"main\"" "   \"String[] args\"" "   \"\" \"\"))" ";; don't move point" "(setq tempo-marks nil)") "\
Template for generating the main method.
Setting this variable defines a template instantiation
command, `jde-gen-main-method', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-main-method (tempo-define-template "main-method" (jde-gen-read-template val) nil "Insert skeleton main method.")) (set-default sym val)))

(defcustom jde-gen-println '("(end-of-line) '&" "\"System.out.println(\" (P \"Print out: \") \");\" '>'n'>") "\
*Template for generating a System.out.println statement." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-println (tempo-define-template "println" (jde-gen-read-template val) nil "Insert println statement.")) (set-default sym val)))

(defcustom jde-gen-beep '("(end-of-line) '&" "\"Toolkit.getDefaultToolkit().beep();\"'>'n'>") "\
*Template for generating a Toolkit.getDefaultToolkit().beep() statement." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-beep (tempo-define-template "beep statement" (jde-gen-read-template val) nil "Insert beep statement.")) (set-default sym val)))

(defcustom jde-gen-property-change-support '("(end-of-line) '&" "\"protected PropertyChangeSupport pcs =  new PropertyChangeSupport(this);\" '>'n '>'n" "\"/**\" '>'n" "\"* Adds a PropertyChangeListener to the listener list.\" '>'n" "\"* The listener is registered for all properties.\" '>'n" "\"*\" '>'n" "\"* @param listener The PropertyChangeListener to be added\" '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"addPropertyChangeListener\"" "  \"PropertyChangeListener listener\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"pcs.addPropertyChangeListener(listener);\" '>'n \"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Removes a PropertyChangeListener from the listener list.\" '>'n" "\"* This removes a PropertyChangeListener that was registered\" '>'n" "\"* for all properties.\" '>'n" "\"*\" '>'n " "\"* @param listener The PropertyChangeListener to be removed\" '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"removePropertyChangeListener\"" "  \"PropertyChangeListener listener\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'>\"pcs.removePropertyChangeListener(listener);\" '>'n \"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Adds a PropertyChangeListener for a specific property.\" '>'n" "\"* The listener will be invoked only when a call on firePropertyChange\" '>'n" "\"* names that specific property.\" '>'n" "\"*\" '>'n" "\"* @param propertyName The name of the property to listen on\" '>'n" "\"* @param listener The PropertyChangeListener to be added\" '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"addPropertyChangeListener\"" "  \"String propertyName, PropertyChangeListener listener\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"pcs.addPropertyChangeListener(propertyName, listener);\" '>'n" "\"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Removes a PropertyChangeListener for a specific property.\" '>'n" "\"*\" '>'n" "\"* @param propertyName The name of the property that was listened on\" '>'n" "\"* @param listener The PropertyChangeListener to be removed\"'>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"removePropertyChangeListener\"" "  \"String propertyName, PropertyChangeListener listener\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"pcs.removePropertyChangeListener(propertyName, listener);\" '>'n" "\"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Reports a bound property update to any registered listeners. \" '>'n" "\"* No event is fired if old and new are equal and non-null.\" '>'n" "\"*\" '>'n" "\"* @param propertyName The programmatic name of the property\" '>'n" "\"*                     that was changed\" '>'n" "\"* @param oldValue The old value of the property\" '>'n" "\"* @param newValue The new value of the property.\" '>'n \"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"firePropertyChange\"" "  \"String propertyName, Object oldValue, Object newValue\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"pcs.firePropertyChange(propertyName, oldValue, newValue);\" '>'n" "\"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Reports a bound property update to any registered listeners. \" '>'n" "\"* No event is fired if old and new are equal and non-null.\" '>'n" "\"* This is merely a convenience wrapper around the more general\" '>'n" "\"* firePropertyChange method that takes Object values.\" '>'n" "\"* No event is fired if old and new are equal and non-null.\" '>'n" "\"*\" '>'n" "\"* @param propertyName The programmatic name of the property\" '>'n" "\"*                     that was changed\" '>'n" "\"* @param oldValue The old value of the property\" '>'n" "\"* @param newValue The new value of the property.\" '>'n \"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"firePropertyChange\"" "  \"String propertyName, int oldValue, int newValue\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"pcs.firePropertyChange(propertyName, oldValue, newValue);\" '>'n" "\"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Reports a bound property update to any registered listeners. \" '>'n" "\"* No event is fired if old and new are equal and non-null.\" '>'n" "\"* This is merely a convenience wrapper around the more general\" '>'n" "\"* firePropertyChange method that takes Object values.\" '>'n" "\"* No event is fired if old and new are equal and non-null.\" '>'n" "\"*\" '>'n" "\"* @param propertyName The programmatic name of the property\" '>'n" "\"*                     that was changed\" '>'n" "\"* @param oldValue The old value of the property\" '>'n" "\"* @param newValue The new value of the property.\" '>'n \"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"firePropertyChange\"" "  \"String propertyName, boolean oldValue, boolean newValue\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"pcs.firePropertyChange(propertyName, oldValue, newValue);\" '>'n" "\"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Fires an existing PropertyChangeEvent to any registered listeners.\" '>'n" "\"* No event is fired if the given event's old and new values are\"'>'n" "\"* equal and non-null. \" '>'n" "\"*\" '>'n" "\"* @param evt The PropertyChangeEvent object.\" '>'n\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"firePropertyChange\"" "  \"PropertyChangeEvent evt\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"pcs.firePropertyChange(evt);\" '>'n \"}\" '>'n '>'n" "\"/**\" '>'n" "\"* Checks if there are any listeners for a specific property.\" '>'n" "\"*\" '>'n" "\"* @param evt The PropertyChangeEvent object.\" '>'n" "\"* @return <code>true</code>if there are one or more listeners\"'>'n" "\"*             for the given property\" '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"boolean\"" "  \"hasListeners\"" "  \"String propertyName\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "'> \"return pcs.hasListeners(propertyName);\" '>'n \"}\" '>'n '>'n'>") "\
*Template for adding property change support to a class." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-property-change-support (tempo-define-template "property change support template" (jde-gen-read-template val) nil "Insert property change support template.")) (set-default sym val)))

(defcustom jde-gen-listener-registry '("(p \"Listener class (fully qualified): \" listenerFQN 'noinsert)" "(tempo-save-named 'listener-class " " (replace-in-string (tempo-lookup-named 'listenerFQN)" "                    \"[^\\\\.]+\\\\.\" \"\"))" "(tempo-save-named 'listener-vector " " (concat (jde-wiz-downcase-initials (tempo-lookup-named 'listener-class))" "         \"s\"))" "(end-of-line) '&" "\"protected Vector \" (s listener-vector) \" = new Vector();\" '>'n '>'n" "\"/**\" '>'n" "\"* The method <CODE>add\" (s listener-class)" "\"</CODE> allows to \" '>'n" "\"* add a new <CODE>\" (s listener-class) \"</CODE>\" '>'n" "\"* that will be notified of incoming events.\" '>'n" "\"*\" '>'n" "\"* @see \" (s listenerFQN) '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  (concat \"add\" (tempo-lookup-named 'listener-class))" "  (concat (tempo-lookup-named 'listener-class) \" l\")" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "(s listener-vector) \".addElement(l);\" '> 'n" "\"}\" '>'n '>'n" "\"/**\" '>'n" "\"* The method <CODE>remove\" (s listener-class)" "\"</CODE> allows to \" '>'n" "\"* remove a <CODE>\" (s listener-class) \"</CODE> that was\" '>'n" "\"* previously registered to be notified of incoming events.\" '>'n" "\"*\" '>'n" "\"* @see \" (s listenerFQN) '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  (concat \"remove\" (tempo-lookup-named 'listener-class))" "  (concat (tempo-lookup-named 'listener-class) \" l\")" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "(s listener-vector) \".removeElement(l);\" '> 'n" "\"}\" '>'n '>'n") "\
*Template for adding a registry for a class of listeners." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-listener-registry (tempo-define-template "listener registry template" (jde-gen-read-template val) nil "Insert listener registry template.")) (set-default sym val)))

(defcustom jde-gen-event-source-fire-method-template '("(p \"Listener class (fully qualified): \" listenerFQN 'noinsert)" "(p \"Listener method name: \" method-name 'noinsert)" "(p \"Method name: \" return-type 'noinsert)" "(p \"Method name: \" params 'noinsert)" "(tempo-save-named 'listener-class " " (replace-in-string (tempo-lookup-named 'listenerFQN)" "                    \"[^\\\\.]+\\\\.\" \"\"))" "(tempo-save-named 'listener-vector " " (concat (jde-wiz-downcase-initials (tempo-lookup-named 'listener-class))" "         \"s\"))" "(tempo-save-named 'fire-method " " (concat \"fire\" (upcase-initials (tempo-lookup-named 'method-name))))" "(tempo-save-named 'param-ids " " (jde-gen-extract-ids-from-params (tempo-lookup-named 'params)))" "(end-of-line) '&" "\"/**\" '>'n" "\"* The method <CODE>\" (s fire-method)" "\"</CODE> is used \" '>'n" "\"* to call the <CODE>\" (s method-name) \"</CODE> method of\" '>'n" "\"* every previously registered <CODE>\" (s listener-class) \"</CODE>.\" '>'n" "\"*\" '>'n" "\"* @see \" (s listenerFQN) '>'n" "\"*/\" '>'n" "(jde-gen-method-signature" "  \"public\"" "  (tempo-lookup-named 'return-type)" "  (tempo-lookup-named 'fire-method)" "  (tempo-lookup-named 'params)" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" " \"for(int i = 0; i < \" (s listener-vector) \".size(); i++)\" '>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"((\" (s listener-class) \")\" (s listener-vector)" "\".elementAt (i)).\" (s method-name) \" (\" (s param-ids) \");\" '> 'n" "\"}\" '>'n" "\"}\" '>'n '>'n") "\
*Template for adding a registry for a class of listeners." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-event-source-fire-method (tempo-define-template "event source fire method template" (jde-gen-read-template val) nil "Insert event source fire method template.")) (set-default sym val)))

(defcustom jde-gen-entity-bean-template '("(jde-import-insert-imports-into-buffer " "  (list \"javax.ejb.*\"" "        \"java.rmi.RemoteException\"))" "'>" "(jde-gen-method-signature" "   \"public\"" "  \"void\"" "  \"ejbActivate\"" "  nil" "  \"RemoteException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbPassivate\"" "  nil" "  \"RemoteException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbLoad\"" "  nil" "  \"RemoteException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbStore\"" "  nil" "  \"RemoteException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbRemove\"" "  nil" "  \"RemoteException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"setEntityContext\"" "  \"EntityContext ctx\"" "  \"RemoteException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"unsetEntityContext\"" "  nil" "  \"RemoteException\"" " )" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n '>") "\
*Template that creates an empty implementation of an EJB Entity Bean." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-entity-bean (tempo-define-template "ejb-entity-bean" (jde-gen-read-template val) nil "Adds an implementation of the EJB Entity Bean interface to the 
class in the current buffer at the current point in the buffer. Before invoking
this command,  position point at the point in the buffer where you want the first 
Entity Bean method to appear. Use `jde-ejb-entity-bean-buffer' to create a complete
skeleton entity bean implementation from scratch.")) (set-default sym val)))

(defcustom jde-gen-session-bean-template '("(jde-import-insert-imports-into-buffer " "  (list \"javax.ejb.*\"" "        \"java.rmi.RemoteException\"))" "'>" "(jde-wiz-update-implements-clause \"SessionBean\")" "'>" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbActivate\"" "  nil" "  \"RemoteException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbPassivate\"" "  nil" "  \"RemoteException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"ejbRemove\"" "  nil" "  \"RemoteException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"setSessionContext\"" "  \"SessionContext ctx\"" "  \"RemoteException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "(jde-gen-method-signature" "  \"public\"" "  \"void\"" "  \"unsetSessionContext\"" "  nil" "  \"RemoteException\"" " )" "'>" "(if jde-gen-k&r " " ()" " 'n)" "\"{\"'>'n" "\"}\"'>'n 'n" "'>") "\
*Template that creates an empty implementation of an EJB Session Bean." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-session-bean (tempo-define-template "ejb-session-bean" (jde-gen-read-template val) nil "Adds an implementation of the EJB Session Bean interface to the 
class in the current buffer at the current point in the buffer. Before invoking
this command,  position point at the point in the buffer where you want the first 
Session Bean method to appear. Use `jde-ejb-session-bean-buffer' to create a complete
skeleton session bean implementation from scratch.")) (set-default sym val)))

(defcustom jde-gen-method-javadoc-comment "template" "\
Specifies the type of javadoc comment generated by
the `jde-gen-method-template'. The choices are

   * Template 

     Uses `jde-javadoc-autodoc-at-line' function to generate
     the documentation.

   * Inherit

     Generates a javadoc comment containing only the 
     javadoc (@inheritDoc) tag. This tag causes javadoc
     to copy the javadoc comment from the abstract 
     method that the generated method implements but
     only if the javadoc for the abstract method is
     also being generated.

   * None

     Specifies that the method template not generate
     a javadoc comment. In this case, javadoc copies
     the comment from the abstract method if its doc
     is also being generated in the same run." :group 'jde-gen :type '(choice (const :tag "Template" "template") (const :tag "Inherit Tag" "inherit") (const :tag "None" "none")))

(defcustom jde-gen-method-template '("(p \"Method modifiers: \" modifiers 'noinsert)" "(p \"Method return type: \" return-type 'noinsert)" "(p \"Method name: \" name 'noinsert)" "(p \"Method parameters: \" parameters 'noinsert)" "(p \"Method exceptions: \" exceptions 'noinsert)" "(p \"Method body: \" default-body 'noinsert)" "(jde-gen-delete-preceding-whitespace) 'n 'n 'p" "(if (string= jde-gen-method-javadoc-comment \"inherit\")" "'(l \"/*\" 'n>" "\"* (@inheritDoc)\" 'n>" "\"*/\" 'n>" "))" "(jde-gen-method-signature" "  (tempo-lookup-named 'modifiers)" "  (tempo-lookup-named 'return-type)" "  (tempo-lookup-named 'name)" "  (tempo-lookup-named 'parameters)" "  (tempo-lookup-named 'exceptions)" " )" "'>" "(jde-gen-electric-brace)" "(s default-body) (jde-gen-indent) 'p'n" "\"}\"'>'n" "(if (string= jde-gen-method-javadoc-comment \"template\")" " (progn (tempo-backward-mark) (tempo-backward-mark) (beginning-of-line)" "   (jde-gen-save-excursion (jde-javadoc-autodoc-at-line))" "   (tempo-forward-mark) nil)" "  (progn (tempo-backward-mark) nil))" "(setq tempo-marks nil) ;; prevent tempo from moving point") "\
*Template for generating a skeleton method. The
`jde-gen-method-javadoc-comment' variable controls whether this
template generates a javadoc comment for the method, and, if so, what
kind of comment. Setting this variable defines a template
instantiation command, `jde-gen-method', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-method (tempo-define-template "method" (jde-gen-read-template val) nil "Insert skeleton method.")) (set-default sym val)))

(defcustom jde-gen-equals-trailing-and-operators nil "\
Specifies whether the '&&' operators in a generated equals
method are added at the end of the line or at the beginning.  If
this variable is t, the operator will be added at the end of the
line, else on the next line before the comparison.  With
`jde-gen-equals-trailing-and-operators' set to nil:

    return (a == o.a)
        && (b == o.b)
        && (s == null ? o.s == null : s.equals(o.s));

Or, with `jde-gen-equals-trailing-and-operators' set to t:

    return (a == o.a) &&
        (b == o.b) &&
        (s == null ? o.s == null : s.equals(o.s));
" :group 'jde-gen :type 'boolean)

(defcustom jde-gen-equals-parens-around-expression nil "\
Specifies whether the generated equals expression should be 
surrounded by parentheses.
With `jde-gen-equals-trailing-and-operators' set to nil:

    return ((a == o.a)
            && (b == o.b)
            && (s == null ? o.s == null : s.equals(o.s)));

Or, with `jde-gen-equals-trailing-and-operators' set to t:

    return ((a == o.a) &&
            (b == o.b) &&
            (s == null ? o.s == null : s.equals(o.s)));
" :group 'jde-gen :type 'boolean)

(defcustom jde-gen-equals-method-template '("'>" "\"/**\" '> 'n" "\" * Check if this object is equal to another object.\" '> 'n" "\" * \" '> 'n" "\" * <p>For the definition of the object equivalence relation\" '> 'n" "\" * see {@link java.lang.Object#equals(Object)}.</p>\" '> 'n" "\" * \" '> 'n" "\" * @param obj another, possibly equal object.\" '> 'n" "\" * \" '> 'n" "\" * @return true if the objects are equal, false otherwise.\" '> 'n" "\" * \" '> 'n" "\" * @see java.lang.Object#equals(Object)\" '> 'n" "\" */\" '> 'n" "(jde-gen-method-signature \"public\" \"boolean\" \"equals\" \"Object obj\")" "(jde-gen-electric-brace)" "\"if (obj == this)\" '> 'n" "\"return true;\" '> 'n '> 'n" "\"if (obj == null || getClass() != obj.getClass())\" '> 'n" "\"return false;\" '> 'n '> 'n" "(jde-gen-equals-return \"obj\" \"o\") '> 'n" "\"}\" '> 'n '>") "\
*Template for creating an equals method.
Setting this variable defines a template instantiation command
`jde-gen-equals-method', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-equals-method (tempo-define-template "java-equals-method" (jde-gen-read-template val) nil "Create an equals method at the current point.")) (set-default sym val)))

(defcustom jde-gen-hashcode-method-template '("'>" "\"/**\" '> 'n" "\" * Calculate the hash code for this object.\" '> 'n" "\" * \" '> 'n" "\" * <p>The rules laid out in J. Blosh's Effective Java are used\" '> 'n" "\" * for the hash code calculation.</p>\" '> 'n" "\" * \" '> 'n" "\" * @return the hash code.\" '> 'n" "\" * \" '> 'n" "\" * @see java.lang.Object#hashCode\" '> 'n" "\" */\" '> 'n" "(jde-gen-method-signature \"public\" \"int\" \"hashCode\" nil)" "(jde-gen-electric-brace)" "(jde-gen-hashcode-body) '> 'n" "\"}\" '> 'n '>") "\
*Template for creating a hashCode method.
Setting this variable defines a template instantiation command
`jde-gen-hashcode-method', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-hashcode-method (tempo-define-template "java-hashcode-method" (jde-gen-read-template val) nil "Create a hashCode method at the current point.")) (set-default sym val)))

(defcustom jde-gen-tostring-method-template '("'>" "\"/**\" '> 'n" "\" * Get a string representation of this object.\" '> 'n" "\" * \" '> 'n" "\" * @return a string representation of this object.\" '> 'n" "\" * \" '> 'n" "\" * @see java.lang.Object#toString\" '> 'n" "\" */\" '> 'n" "(jde-gen-method-signature \"public\" \"String\" \"toString\" \"\")" "(jde-gen-electric-brace)" "(jde-gen-tostring-return) '> 'n" "\"}\" '> 'n '>" "(jde-import-one-class \"org.apache.commons.lang.builder.ToStringBuilder\")") "\
*Template for creating an toString method.
Setting this variable defines a template instantiation
command `jde-gen-tostring-method', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-gen-tostring-method (tempo-define-template "java-tostring-method" (jde-gen-read-template val) nil "Create an toString method at the current point.")) (set-default sym val)))

(defcustom jde-gen-exception-buffer-template (list "(open-line 1) (funcall jde-gen-boilerplate-function)" "(jde-gen-get-package-statement)" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\" * Exception <code>\" (jde-parse-get-buffer-unqualified-class) \"</code>.\" '> 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" * Created: \" (current-time-string) '> 'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-author-tag))" "\" \" (jde-gen-save-excursion (jde-javadoc-insert 'tempo-template-jde-javadoc-version-tag))" "\" \" (jde-javadoc-insert-end-block)" "\"public class \"" "(jde-parse-get-buffer-unqualified-class)" "\" \" (jde-gen-get-extend-class)" "(jde-gen-electric-brace)" "'p'n" "'> (jde-javadoc-insert-start-block)" "\"* Constructs a new <code>\" (jde-parse-get-buffer-unqualified-class) \"</code> with\" '>'n" "\"* <code>null</code> as its detail message.\" '>'n" "'> (jde-javadoc-insert-end-block)" "(jde-gen-method-signature \"public\" nil (jde-parse-get-buffer-unqualified-class) nil)" "(jde-gen-electric-brace)" "\"}\"'>'n" "'n" "'> (jde-javadoc-insert-start-block)" "\"* Constructs a new <code>\" (jde-parse-get-buffer-unqualified-class) \"</code> with\" '>'n" "\"* the specified detail message.\" '>'n" "'> (jde-javadoc-insert-empty-line)" "\"* @param message the detail message string.\" '> 'n" "'> (jde-javadoc-insert-end-block)" "(jde-gen-method-signature \"public\" nil (jde-parse-get-buffer-unqualified-class) \"String message\")" "(jde-gen-electric-brace)" "\"super(message);\" '> 'n" "\"}\" '> 'n" "'n" "'> (jde-javadoc-insert-start-block)" "\"* Constructs a new <code>\" (jde-parse-get-buffer-unqualified-class) \"</code> with\" '>'n" "\"* the specified cause and a detail message of\" '> 'n" "\"* <code>(cause == null ? null : cause.toString())</code>\" '> 'n" "\"* (which typically contains the class and detail message of cause).\" '> 'n" "'> (jde-javadoc-insert-empty-line)" "\"* @param cause the causing throwable. A null value is permitted\" '> 'n" "\"*     and indicates that the cause is nonexistent or unknown.\" '> 'n" "'> (jde-javadoc-insert-end-block)" "(jde-gen-method-signature \"public\" nil (jde-parse-get-buffer-unqualified-class) \"Throwable cause\")" "(jde-gen-electric-brace)" "\"super(cause == null ? (String) null : cause.toString());\" '> 'n" "\"initCause(cause);\" '> 'n" "\"}\" '> 'n" "'n" "'> (jde-javadoc-insert-start-block)" "\"* Constructs a new <code>\" (jde-parse-get-buffer-unqualified-class) \"</code> with\" '>'n" "\"* the specified cause and message.\" '> 'n" "'> (jde-javadoc-insert-empty-line)" "\"* @param message the detail message string.\" '> 'n" "\"* @param cause the causing throwable. A null value is permitted\" '> 'n" "\"*     and indicates that the cause is nonexistent or unknown.\" '> 'n" "'> (jde-javadoc-insert-end-block)" "(jde-gen-method-signature \"public\" nil (jde-parse-get-buffer-unqualified-class) \"String message,Throwable cause\")" "(jde-gen-electric-brace)" "\"super(message);\" '> 'n" "\"initCause(cause);\" '> 'n" "\"}\" '> 'n" "\"}\" '>" "(if jde-gen-comments (concat \" // \" (jde-parse-get-buffer-unqualified-class)))" "'>'n") "\
*Template for a new exception class.
Setting this variable defines a template instantiation
command `jde-gen-exception', as a side-effect." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (tempo-define-template "java-exception-buffer-template" (jde-gen-read-template val) nil "Insert a generic Java exception buffer skeleton.") (defalias 'jde-gen-exception (list 'lambda (list) (list 'interactive) (list 'tempo-template-java-exception-buffer-template))) (set-default sym val)))

(defcustom jde-gen-code-templates (list (cons "Get Set Pair" 'jde-gen-get-set) (cons "main method" 'jde-gen-main-method) (cons "toString Method (Apache)" 'jde-gen-tostring-method) (cons "Equals Method" 'jde-gen-equals-method) (cons "Hash Code Method" 'jde-gen-hashcode-method) (cons "Deep clone" 'jde-gen-deep-clone) (cons "Action Listener" 'jde-gen-action-listener) (cons "Change Listener" 'jde-gen-change-listener) (cons "Window Listener" 'jde-gen-window-listener) (cons "Mouse Listener" 'jde-gen-mouse-listener) (cons "Mouse Motion Listener" 'jde-gen-mouse-motion-listener) (cons "Inner Class" 'jde-gen-inner-class) (cons "println" 'jde-gen-println) (cons "beep" 'jde-gen-beep) (cons "property change support" 'jde-gen-property-change-support) (cons "EJB Entity Bean" 'jde-gen-entity-bean) (cons "EJB Session Bean" 'jde-gen-session-bean)) "\
*Specifies available autocode templates.
The value of this variable is an association list. The car of
each element specifies a template name. The cdr specifies
a command that inserts the template into a buffer. See the function
`tempo-define-template' for any easy way to create a template
insertion command." :group 'jde-gen :type '(repeat (cons :tag "Template" (string :tag "Name") (function :tag "Command"))) :set '(lambda (sym val) (let ((n (length val)) (i 0)) (setq jde-gen-template-names (list)) (while (< i n) (setq jde-gen-template-names (append jde-gen-template-names (list (cons (car (nth i val)) (1+ i))))) (setq i (1+ i)))) (set-default sym val)))

(defcustom jde-gen-cflow-enable t "\
Enables abbreviations for Java control flow constructs." :group 'jde-gen :type 'boolean)

(defcustom jde-gen-comments nil "\
*If no-nil, use comments, else do not use comments.
with comments:

      try {

      } catch (Exception e) {

      } // end of try-catch


witout comments:

      try {

      } catch (Exception e) {

      }

Setting this variable to t, uses comments in skeletons and templates." :group 'jde-gen :type 'boolean)

(defcustom jde-gen-cflow-if '("'> \"if\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"if-clause: \" clause)" "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " "'(l \" // end of if (\" (s clause) \")\"))" "'>'n") "\
Skeleton if statement. To insert the if statement at point, type if
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode'" :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "if" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-else '("'> \"else\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of else\"))" "'>'n") "\
Skeleton else statement. To insert the statement at point, type else
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "else" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-if-else '("'> \"if\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"if-clause: \" clause)" "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\" '>" "(if jde-gen-comments " " '(l \" // end of if (\" (s clause) \")\" '>'n)" " (if jde-gen-k&r " "  jde-gen-conditional-padding-3 " "  'n))" "'> \"else\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of if (\" (s clause) \") else\"))" "'>'n") "\
Skeleton if-else statement. To insert the statement at point, type ife
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "ife" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-else-if '("'> \"else if\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"else-if-clause: \" clause) " "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of else if (\" (s clause) \")\"))" "'>'n") "\
Skeleton else-if statement. To insert the statement at point, type eif
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "eif" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-while '("'> \"while\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"while-clause: \" clause) " "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of while (\" (s clause) \")\"))" "'>'n") "\
Skeleton while statement. To insert the statement at point, type while
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "while" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-for '("'> \"for\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"for-clause: \" clause) " "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of for (\" (s clause) \")\"))" "'>'n") "\
Skeleton for statement. To insert the statement at point, type for
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "for" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-for-i '("'> \"for\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 \"int \" (p \"variable: \" var) " "\" = 0; \" (s var) \" < \" (p \"upper bound: \" upper-bound) \"; \" (s var) \"++\"" "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of for (int \" (s var) \" = 0; \"" "(s var) \" < \" (s upper-bound) \"; \" (s var) \"++)\"))" "'>'n") "\
Skeleton for i statement. To insert the statement at point, type fori
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information.

Note: `tempo-interactive' must be set to a non-nil value to be prompted
      for variable name and upper-bounds information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "fori" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-for-iter '("'> \"for\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 \"Iterator \" (p \"variable: \" var) " "\" = \" (p \"collection: \" coll) \".iterator(); \"" "(s var) \".hasNext();\"" "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r" "(s var) \".next();\" '>'n'>" "\"}\"" "(if jde-gen-comments " " '(l \" // end of for (Iterator \" (s var) \" = \" (s coll)" " \".iterator(); \" (s var) \".hasNext();)\"))" "'>'n") "\
Skeleton for iterator statement. To insert the statement at point,
type foriter and then space.  Note that abbrev mode must be
enabled. See `jde-enable-abbrev-mode' for more information.

Note: `tempo-interactive' must be set to a non-nil value to be prompted
      for variable name and collection name information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "foriter" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-switch '("'> \"switch\" jde-gen-conditional-padding-1 " " \"(\" jde-gen-conditional-padding-2 (p \"switch-condition: \" clause) " "       jde-gen-conditional-padding-2 \")\"" "'>" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "\"case \" (p \"first value: \" first-value) \":\"'>'n" "'p'n" "\"break;\"'>'n" "\"default:\"'>'n'>" "\"break;\"'>'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of switch (\" (s clause) \")\"))" "'>'n") "\
Skeleton switch statement. To insert the statement at point, type switch
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "switch" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-case '("\"case \" (p \"value: \" value) \":\"'>'n" "'p'n" "\"break;\"'>") "\
Skeleton case statement. To insert the statement at point, type case
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "case" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-try-catch '("'> \"try \"" "(jde-gen-electric-brace)" "'r'n" "\"}\" '>" "(if jde-gen-comments " " '(l \" // end of try\" '>'n)" " (if jde-gen-k&r " "  jde-gen-conditional-padding-3 " "  'n))" "\"catch\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"catch what: \" clause) \" e\"" "      jde-gen-conditional-padding-2 \")\" '>" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'p'n" "\"}\"" " (if jde-gen-comments " "	'(l \" // end of try-catch\"))" "'>'n") "\
Skeleton try-catch statement. To insert the statement at point, type try
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "try" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-catch '("'> \"catch\" jde-gen-conditional-padding-1  " "\"(\" jde-gen-conditional-padding-2 (p \"catch what: \" clause) \" e\"" "      jde-gen-conditional-padding-2 \")\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of catch\"))" "'>'n") "\
Skeleton catch statement. To insert the statement at point, type catch
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "catch" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-try-finally '("'> \"try \"" "(jde-gen-electric-brace)" "'r'n" "\"}\" '>" "(if jde-gen-k&r " "  jde-gen-conditional-padding-3 " " 'n)" "\"catch\" jde-gen-conditional-padding-1 " "\"(\" jde-gen-conditional-padding-2 (p \"catch what: \" clause) \" e\"" "      jde-gen-conditional-padding-2 \")\" '>" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\" '> " "(if jde-gen-k&r " "  jde-gen-conditional-padding-3 " " 'n)" "\"finally\" '>" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of try-finally\"))" "'>'n") "\
Skeleton try-catch-finally statement. To insert the statement at point, type
tryf and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "tryf" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-gen-cflow-finally '("'> \"finally\"" "(jde-gen-electric-brace jde-gen-conditional-padding-3)" "'r'n" "\"}\"" "(if jde-gen-comments " " '(l \" // end of finally\"))" "'>'n") "\
Skeleton finally statement. To insert the statement at point, type finally
and then space. Note that abbrev mode must be enabled. See
`jde-enable-abbrev-mode' for more information." :group 'jde-gen :type '(repeat string) :set '(lambda (sym val) (jde-gen-define-abbrev-template "finally" (jde-gen-read-template val)) (set-default sym val)))

(defcustom jde-electric-return-p nil "\
Specifies whether the JDEE's electric return mode is 
enabled for this session or project. This mode causes the JDEE to
match an open brace at the end of a line with a closing
brace. You can use `jde-toggle-electric-return' at any
time to enable or disable eelctric return mode." :group 'jde-gen :type 'boolean :set '(lambda (sym val) (if (featurep 'jde) (let ((curr-project (with-current-buffer jde-current-buffer jde-current-project))) (mapc (lambda (buf) (with-current-buffer buf (let ((key (car (read-from-string "[return]")))) (if val (define-key (current-local-map) key 'jde-electric-return) (local-unset-key key))))) (jde-get-project-source-buffers)))) (setq jde-electric-return-mode val) (set-default sym val)))

(defcustom jde-newline-function '(newline) "\
Indent command that `jde-electric-return' calls." :group 'jde-gen :type '(list (radio-button-choice :format "%t 
%v" :tag "Function: " :entry-format " %b %v" (const newline) (const newline-and-indent) (const align-newline-and-indent) (function my-custom-newline-function))))

;;;***

;;;### (autoloads (jde-help-browser-function jde-help-wget-command-line-options jde-help-wget-timeout jde-help-wget-tries jde-help-remote-file-exists-function jde-help-use-frames jde-help-docsets) "jde-help" "lisp/jde-help.el")
(defconst custom-define-current-source-file "jde-help.el")

(defcustom jde-help-docsets (list (list "JDK API" "" nil)) "\
*Lists collections of HTML files documenting Java classes. 
This list is used by the `jde-help-class' command to find help for 
a class. You can specify the following information for each docset:

Docset type

  The following types are valid: 

  * JDK API

    JDK API documentation created by JDK developer (e.g., Sun)

  * User (javadoc)

    User collection in javadoc format.

  * User (not javadoc)

    User collection not in javadoc format.

Docset directory

   Directory containing the collection, e.g., d:/jdk1.3/docs/api.  If
   the docset type is `JDK API' and this field is the empty string, the
   JDE looks for the docset in the `docs/api' subdirectory of the directory
   returned by `jde-get-jdk-dir'. The docset directory may be located on
   a remote system in which case this field should specify the URL of the
   docset directory, e.g., http://www.javasoft.com/j2se/1.3/docs/api. The
   GNU utility, wget, or the w3 function `url-file-exists' must be
   installed on your system to find javadoc pages located on remote
   systems. Native Windows and cygwin ports of wget are readily available
   on the Internet. Make sure that wget is in Emacs `exec-path' before
   attempting to access documentation on remote systems. See
   `jde-help-remote-file-exists-function' for more information.

Doc lookup function

   Should specify a function that accepts a fully qualified class name, 
   e.g., java.awt.String, and a docset directory and returns a path to 
   an HTML file that documents that class, e.g., 
   d:/jdk1.2/docs/api/java/awt/String.html. This field must be specified
   for non-javadoc collections. It is ignored for javadoc colletions.
" :group 'jde-project :type '(repeat (list (radio-button-choice :format "%t 
%v" :tag "Docset type:" (const "JDK API") (const "User (javadoc)") (const "User (not javadoc)")) (file :tag "Docset directory") (choice :tag "Doc lookup function" (const nil) function))))

(defcustom jde-help-use-frames t "\
A non-nil value makes the functions:`jde-help-symbol',   
 `jde-help-class-member' and `jde-help-class' use frames when displaying    
 the html javadocs." :group 'jde-project :type 'boolean)

(defcustom jde-help-remote-file-exists-function (list "wget") "\
Specifies the function the jde uses to retrieve remote documents.
wget is a Unix utility available on Windows as part of the Cygwin
package. `url-file-exists' is part of the url Emacs Lisp library,
which is included in the Emacs w3 package." :group 'jde-project :type '(list (radio-button-choice :format "%t 
%v" :tag "Function:" (const "wget") (const "url-file-exists"))) :set '(lambda (sym val) (if (and (string= (car val) "url-file-exists") (locate-library "url")) (autoload 'url-file-exists "url" nil nil nil)) (set-default sym val)))

(defcustom jde-help-wget-tries nil "\
Specifies the number of times that the JDEE should try getting
documentation from a remote site This option applies only if wget is
the`jde-help-remote-file-exists-function'. It sets wget's --tries 
command-line option. It is helpful in situations where
one of the the sites in `jde-help-docsets' is not always reachable." :group 'jde-project :type '(choice (const :tag "Try once" :value nil) (const :tag "Never stop trying" :value 0) (integer :tag "Number of retries" :value 1)))

(defcustom jde-help-wget-timeout nil "\
Specifies the length of time that the JDEE should wait for a remote site
to respond to a request for a document. This option applies only if wget is
the`jde-help-remote-file-exists-function'. It sets wget's --timeout 
command-line option. It is helpful in situations where
one of the the sites in `jde-help-docsets' is not always reachable." :group 'jde-project :type '(choice (const :tag "Default (900 s.)" :value nil) (const :tag "Disable timeout checking" :value 0) (integer :tag "Timeout (seconds)" :value 900)))

(defcustom jde-help-wget-command-line-options nil "\
Specifies additional options (beyond --spider, --tries and
--timeout) to pass to wget, if wget is used for
`jde-help-remote-file-exists-function'." :group 'jde-project :type 'string)

(defcustom jde-help-browser-function "browse-url" "\
Specifies the function that the JDEE uses to display
HTML pages." :group 'jde-project :type '(choice (const :tag "browse-url" :value "browse-url") (const :tag "w3m-browse-url" :value "w3m-browse-url") (function :tag "Other" :value identity)))

;;;***

;;;### (autoloads (jde-imenu-include-classdef jde-imenu-sort jde-imenu-modifier-abbrev-alist jde-imenu-include-modifiers jde-imenu-include-signature jde-imenu-create-index-function jde-imenu-enable) "jde-imenu" "lisp/jde-imenu.el")
(defconst custom-define-current-source-file "jde-imenu.el")

(defcustom jde-imenu-enable t "\
*Enables creation of a classes index menu in the Emacs menubar." :group 'jde-project :type 'boolean)

(defcustom jde-imenu-create-index-function 'semantic-create-imenu-index "\
*Function used to create the \"Classes\" imenu.
Files must be reopened to update the imenu when this option is
changed. The default is the generic `semantic-create-imenu-index'." :group 'jde-project :type 'function)

(defcustom jde-imenu-include-signature t "\
*If non-nil imenu displays full method signatures and field types.
Use *Rescan* to rebuild the imenu when you have changed this option." :group 'jde-project :type 'boolean)

(defcustom jde-imenu-include-modifiers nil "\
*If non-nil imenu shows abbreviations for Java modifiers.
Use *Rescan* to rebuild the imenu when you have changed this option.
See also `jde-imenu-modifier-abbrev-alist'." :group 'jde-project :type 'boolean)

(defcustom jde-imenu-modifier-abbrev-alist jde-imenu-default-modifier-abbrev-alist "\
*Alist of character abbreviations for Java modifiers.
Each association has the form (MODIFIER . CHARACTER) where MODIFIER is
a valid Java modifier string (see `jde-imenu-valid-modifiers-regexp')
and CHARACTER any valid character. Modifiers without any valid
association are not displayed (see also `jde-imenu-include-modifiers')." :group 'jde-project :type '(repeat (cons :tag "Abbrev" (string :tag "Modifier" :validate (lambda (widget) (jde-imenu-modifier-field-validate widget)) "") (choice :tag "Abbreviation" (const :tag "None" nil) (character :tag "Character") (integer :tag "Character value" :validate (lambda (widget) (jde-imenu-abbrev-field-validate widget)))))))

(defcustom jde-imenu-sort nil "\
*If non-nil sorts items in the index menu.
You can choose:

- - 'asc   to sort by tag name ascending (ignoring case).
- - 'desc  to sort by tag name descending (ignoring case).

Use *Rescan* to rebuild the imenu when you have changed this option." :group 'jde-project :type '(choice (const :tag "No sort" nil) (const :tag "Ascending" asc) (const :tag "Descending" desc)) :set '(lambda (sym val) (setq semantic-imenu-sort-bucket-function (cond ((eq val 'asc) 'semantic-sort-tokens-by-name-increasing-ci) ((eq val 'desc) 'semantic-sort-tokens-by-name-decreasing-ci) (t nil))) (set-default 'semantic-imenu-sort-bucket-function semantic-imenu-sort-bucket-function) (set-default sym val)))

(defcustom jde-imenu-include-classdef t "\
*If non-nil `jde-imenu-index-class' adds *class def* items in imenu
index to go to class definition." :group 'jde-project :type 'boolean)

;;;***

;;;### (autoloads (jde-import-collapse-imports-threshold jde-import-auto-collapse-imports jde-import-blank-line-between-groups jde-import-insert-group-names jde-import-default-group-name jde-import-group-of-rules jde-import-group-function jde-import-sorted-groups jde-import-reverse-sort-group jde-import-auto-sort-function jde-import-auto-sort jde-import-excluded-classes) "jde-import" "lisp/jde-import.el")
(defconst custom-define-current-source-file "jde-import.el")

(defcustom jde-import-excluded-classes '(("^bsh\\..*") ("^java\\.lang\\.[^.]*$" . t) ("^sun\\..*") ("^com\\.sun\\..*") (jde-import-current-package-p . t)) "\
*Specifies classes that should not be imported into a source file.
\"Exclude test\" should be either a regular expression or a function
whose only argument is the fully qualified class name.
Import commands excludes any classes whose fully qualified name matches
\"Regexp\" and any classes for which the \"Test function\" returns non-nil.
If \"Exclude synonyms\" is non-nil, all classes with the same unqualified name
will also be excluded. This is useful for classes of packages which will be
imported implicitly (i.e. java.lang.* and the package of the importing class).
If more than one fully qualified class names match the unqualified name that you specify,
the command prompts you to select only the classes that are not excluded." :group 'jde-project :type '(repeat (cons :tag "Exclude rule" (choice :tag "Exclude test" (regexp :tag "Regexp") (function :tag "Test function")) (boolean :tag "Exclude synonyms"))))

(defcustom jde-import-auto-sort nil "\
*Automatically resort import statements after a `jde-import-import'.
If non-nil, the JDE automatically resorts the import statements when a new import statement is added using `jde-import-import' or `jde-import-find-and-import'." :group 'jde-project :type 'boolean)

(defcustom jde-import-auto-sort-function 'jde-import-sort "\
*Function to call to automatically  sort imports statements after a `jde-import-import'.  
Usually `jde-import-sort' or `jde-import-organize'.  Enabled if  `jde-import-auto-sort' is not nil." :group 'jde-project :type 'function)

(defcustom jde-import-reverse-sort-group nil "\
*Non-nil to sort each import group's packages in reverse alphabetic
order.  See command `jde-import-organize'.  Note: For sorting the
groups, see variable `jde-import-sorted-groups'." :group 'jde-project :type 'boolean)

(defcustom jde-import-sorted-groups nil "\
*Non-nil to sort import groups in alphabetic order. Order may
be specified as alphabetic, reverse alphabetical or as implicitly 
specified by `jde-import-group-of-rules'. In the latter case the
order of groups is the same as their appearance in 
`jde-import-group-of-rules'.
See command `jde-import-organize'. Note: For sorting the packages
within each group, see variable `jde-import-reverse-sort-group'." :group 'jde-project :type '(choice :tag "Order" (const :tag "No sort" nil) (const :tag "group-of-rules order" gor) (const :tag "alphabetic order" asc) (const :tag "reverse alphabetic order" desc)))

(defcustom jde-import-group-function 'jde-import-group-of "\
*Function used to associate an import token to a group.
It receives one argument, the import token and must return a group
name string or nil if the import does not belong to any group.  The
function `jde-import-group-of' is the default value." :group 'jde-project :type 'function)

(defcustom jde-import-group-of-rules '(("^javax?\\.")) "\
*Import group definitions used by `jde-import-group-of'.
Each group definition is a pair (REGEXP . GROUP) where:
- - REGEXP is a regexp that import names of this group must match.
- - GROUP is a group name or the index of the match data returned as
    group name or nil if REGEXP is the group name." :group 'jde-project :type '(repeat (cons :tag "Group Rule" regexp (choice :tag "Group Name" (string :tag "A String") (integer :tag "Match data at") (const :tag "The Regexp" nil)))) :set '(lambda (sym val) (set-default sym (delete '("") val))))

(defcustom jde-import-default-group-name nil "\
*Default group name if no group name is found.
If a group name is not found in `jde-import-group-of-rules' then this
group name is used.  If nil no default group name is used." :group 'jde-project :type '(choice (string :tag "A String") (const :tag "none" nil)))

(defcustom jde-import-insert-group-names nil "\
*If non-nil `jde-import-organize' inserts group name before imports.
See also the options `jde-import-group-of-rules' and
`jde-import-default-group-name'." :group 'jde-project :type 'boolean)

(defcustom jde-import-blank-line-between-groups t "\
*If non-nil `jde-import-organize' inserts a blank line between groups.
See also the options `jde-import-group-of-rules' and
`jde-import-default-group-name'." :group 'jde-project :type 'boolean)

(defcustom jde-import-auto-collapse-imports nil "\
*If non-nil jde will automatically collapse imports when imports are
inserted." :group 'jde-project :type 'boolean)

(defcustom jde-import-collapse-imports-threshold 2 "\
Threshold level used by `jde-import-collapse-imports' to decide when a
package star import is used instead of single imports. If N is the number of
classes imported by the current buffer from a package and N is >= to the
threshhold, the JDEE replaces the class imports with a package import.
Setting the threshold to 0 causes the JDE to not collapse anything at
all." :group 'jde-project :type 'number)

;;;***

;;;### (autoloads (jde-java-font-lock-api-name-filter jde-java-font-lock-api-file jde-java-font-lock-faces jde-java-font-lock-max-names-by-regexp jde-use-font-lock) "jde-java-font-lock" "lisp/jde-java-font-lock.el")
(defconst custom-define-current-source-file "jde-java-font-lock.el")

(defcustom jde-use-font-lock t "\
*Turn on font-locking if non-nil.
Set to nil to disable the use of font-locking." :group 'jde-project :type 'boolean)

(defcustom jde-java-font-lock-max-names-by-regexp 100 "\
*Maximum number of user defined names that one regexp can match.
No limit if less than 1.  For speed, the default value of 100 seems to
be a good compromize between the number of font lock keyword regexps
to match and the complexity of each regexp.

WARNING: It seems XEmacs search fails with a very long regexp.  So if
you have a lot of user's defined names don't use a value less than 1!" :group 'jde-project :type 'integer)

(defgroup jde-java-font-lock-faces nil "Specific JDE faces for highlighting Java sources." :prefix "jde-java-font-lock-" :group (if (featurep 'xemacs) 'font-lock-faces 'font-lock-highlighting-faces))

(defcustom jde-java-font-lock-api-file (expand-file-name "~/jde-java-font-lock.api") "\
*File which contains a list of user's defined names to fontify.
If nil no name fontification occurs.  Otherwise the specified file must
contain one name by line.  Lines not beginning with a letter are
ignored.  When you change this file or modify its content a new cache
of font lock regular expressions will be rebuilt when restarting
Emacs.  Also, you can manually rebuild the cache and update font lock
keywords by entering the command:

\\[universal-argument] \\[jde-java-font-lock-setup-keywords]." :group 'jde-project :type '(choice :tag "Names" (const :tag "No" nil) (file :tag "In file" :format "%t
%v")))

(defcustom jde-java-font-lock-api-name-filter nil "\
*Function used to filter a name." :group 'jde-project :type 'function)

;;;***

;;;### (autoloads (jde-javadoc-gen-args jde-javadoc-gen-verbose jde-javadoc-gen-nonavbar jde-javadoc-gen-nohelp jde-javadoc-gen-noindex jde-javadoc-gen-notree jde-javadoc-gen-nodeprecatedlist jde-javadoc-gen-nodeprecated jde-javadoc-gen-serialwarn jde-javadoc-gen-version jde-javadoc-gen-author jde-javadoc-gen-use jde-javadoc-gen-split-index jde-javadoc-gen-stylesheetfile jde-javadoc-gen-helpfile jde-javadoc-gen-bottom jde-javadoc-gen-footer jde-javadoc-gen-header jde-javadoc-gen-docletpath jde-javadoc-gen-doclet jde-javadoc-gen-overview jde-javadoc-gen-window-title jde-javadoc-gen-doc-title jde-javadoc-gen-group jde-javadoc-gen-link-offline jde-javadoc-gen-link-online jde-javadoc-gen-link-URL jde-javadoc-gen-destination-directory jde-javadoc-gen-packages jde-javadoc-gen-detail-switch jde-javadoc-display-doc jde-javadoc) "jde-javadoc-gen" "lisp/jde-javadoc-gen.el")
(defconst custom-define-current-source-file "jde-javadoc-gen.el")

(defgroup jde-javadoc nil "Javadoc template generator" :group 'jde :prefix "jde-javadoc-")

(defcustom jde-javadoc-display-doc t "\
*Display the documentation generated by the `jde-javadoc-make' command. ." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-detail-switch (list "-protected") "\
Specifies what access level switch to use.
  -public will show only public classes and members
  -protected will show protected and public classes and members
  -package will show package, protected, and public classes and members
  -private will show all classes and members" :group 'jde-javadoc :type '(list (radio-button-choice :format "%t 
%v" :tag "Select the detail level switch you want:" (const "-public") (const "-protected") (const "-package") (const "-private"))))

(defcustom jde-javadoc-gen-packages nil "\
Specifies which packages or files javadoc should be run on.
" :group 'jde-javadoc :type '(repeat (string :tag "Path")))

(defcustom jde-javadoc-gen-destination-directory "JavaDoc" "\
Specifies the directory where javadoc will put the generated files.
The path may start with a tilde (~) or period (.) and may include
environment variables. The JDEE replaces a ~ with your home directory.
If `jde-resolve-relative-paths-p' is nonnil, the JDEE replaces the
. with the path of the current project file. The JDEE replaces each
instance of an environment variable with its value before inserting it
into the javadoc command line." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-link-URL nil "\
Specifies what URL's to link the generated files to.
   For more information, look at the -link option of the javadoc tool." :group 'jde-javadoc :type '(repeat (string :tag "URL")))

(defcustom jde-javadoc-gen-link-online nil "\
Specifies whether or not to use jde-javadoc-gen-link-URL." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-link-offline nil "\
Specifies URLs to link to and the local path to the directory holding the package-list for each URL.
   The second argument can be a URL (http: or file:). If it is a relative file name, it is relative to the directory
   from which javadoc is run." :group 'jde-javadoc :type '(repeat (cons :tag "Remote URL and directory holding package-list for that URL" (string :tag "URL") (string :tag "Path"))))

(defcustom jde-javadoc-gen-group nil "\
Specifies groups of packages with a group heading and package pattern.
   The heading is usually a string like Extension Packages. The pattern is
   any package name or wildcard matching that name. You can specify several
   packages by separating the package names by a semicolon." :group 'jde-javadoc :type '(repeat (cons :tag "Package group name and contents" (string :tag "Heading") (string :tag "Package Pattern"))))

(defcustom jde-javadoc-gen-doc-title "" "\
Specifies the title to be placed near the top of the overview summary file." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-window-title "" "\
Specifies what should be placed in the HTML <title> tag.
   Quotations inside the title should be escaped." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-overview "" "\
Specifies where to get an alternate overview-summary.html.
   The path is relative to the sourcepath." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-doclet "" "\
Specifies the class file that starts an alternate doclet
   to generate the html files. This path is relative to docletpath" :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-docletpath nil "\
Specifies the path in which the doclet should be searched for." :group 'jde-javadoc :type '(repeat (string :tag "Path")))

(defcustom jde-javadoc-gen-header "" "\
Specifies what html code should be placed at the top of each output file." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-footer "" "\
Specifies what html code should be placed at the bottom of each output file." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-bottom "" "\
Specifies what text or html code should be placed at the bottom
   below the navigation bar." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-helpfile "" "\
Specifies the help file to be used for the Help link in the Navigation bar." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-stylesheetfile "" "\
Specifies the path to an alternate HTML stylesheet file." :group 'jde-javadoc :type 'string)

(defcustom jde-javadoc-gen-split-index nil "\
Specifies whether or not the index should be split alphabetically
   one file per letter." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-use nil "\
Specifies whether or not to create \"Use\" pages" :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-author t "\
Specifies whether or not to use @author tags" :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-version t "\
Specifies whether or not to use @version tags" :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-serialwarn nil "\
Specifies whether or not to generate compile-time errors for missed @serial tags" :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-nodeprecated nil "\
Specifies whether or not to remove all references to deprecated code" :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-nodeprecatedlist nil "\
Specifies whether or not to remove references to deprecated code
   from the navigation bar, but not the rest of the documents." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-notree nil "\
Specifies whether or not to omit generating the class/interface hierarchy." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-noindex nil "\
Specifies whether or not to omit generating the index." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-nohelp nil "\
Specifies whether or not to omit the HELP link in the navigation bar of each page." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-nonavbar nil "\
Specifies whether or not to omit generating the navigation bar at the top of each page." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-verbose nil "\
Specifies whether or not javadoc should be verbose about what it is doing." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-gen-args nil "\
Specifies any other arguments that you want to pass to javadoc." :group 'jde-javadoc :type '(repeat (string :tag "Argument")))

;;;***

;;;### (autoloads (jde-javadoc-checker-level jde-javadoc-check-undeclared-exception-flag jde-javadoc-end-block-template jde-javadoc-version-tag-template jde-javadoc-author-tag-template jde-javadoc-exception-tag-template jde-javadoc-return-tag-template jde-javadoc-param-tag-template jde-javadoc-describe-field-template jde-javadoc-describe-method-template jde-javadoc-describe-constructor-template jde-javadoc-describe-interface-template jde-javadoc-describe-class-template jde-javadoc) "jde-javadoc" "lisp/jde-javadoc.el")
(defconst custom-define-current-source-file "jde-javadoc.el")

(defgroup jde-javadoc nil "JDE javadoc utilities" :group 'jde :prefix "jde-javadoc-")

(defcustom jde-javadoc-describe-class-template "\"* Describe class \" (jde-javadoc-code name) \" here.\"" "\
*Line template used to describe a class.
If nil the line is not inserted.
The variable 'name' is set to the class name.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-describe-class'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-describe-interface-template "\"* Describe interface \" (jde-javadoc-code name) \" here.\"" "\
*Line template used to describe an interface.
If nil the line is not inserted.
The variable 'name' is set to the interface name.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-describe-interface'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-describe-constructor-template "\"* Creates a new \" (jde-javadoc-code name) \" instance.\"" "\
*Line template used to describe a constructor.
If nil the line is not inserted.
The variable 'name' is set to the constructor name (that is the class
name).  See `jde-javadoc-autodoc-at-line' for usage.  Define the
template variable `tempo-template-jde-javadoc-describe-constructor'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-describe-method-template "\"* Describe \" (jde-javadoc-code name) \" method here.\"" "\
*Line template used to describe a method.
If nil the line is not inserted.
The variable 'name' is set to the method name.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-describe-method'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-describe-field-template "\"* Describe \" (jde-javadoc-field-type modifiers)\n \" \" (jde-javadoc-code name) \" here.\"" "\
*Line template used to describe a method.
If nil the line is not inserted.
The variable 'name' is set to the field name.
The variable 'type' is set to the field type.
The variable 'modifiers' is set to the field modifiers.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-describe-field'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-param-tag-template "\"* @param \" name \" \" (jde-javadoc-a type)\n \" \" (jde-javadoc-code type) \" value\"" "\
*Line template used to describe a parameter.
If nil the line is not inserted.
The variable 'name' is set to the parameter name.
The variable 'type' is set to the parameter type.
A line is inserted for each parameter.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-param-tag'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-return-tag-template "\"* @return \" (jde-javadoc-a type)\n \" \" (jde-javadoc-code type) \" value\"" "\
*Line template used to describe a returned value.
If nil the line is not inserted.
The variable 'type' is set to the returned type.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-return-tag'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-exception-tag-template "\"* @exception \" type \" if an error occurs\"" "\
*Line template used to describe an exception.
If nil the line is not inserted.
The variable 'type' is set to the exception type.
A line is inserted for each exception in the 'throws' clause.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-exception-tag'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-author-tag-template "\"* @author <a href=\\\"mailto:\" user-mail-address\n \"\\\">\" user-full-name \"</a>\"" "\
*Line template used to give an author.
If nil the line is not inserted.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-author-tag'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-version-tag-template "\"* @version 1.0\"" "\
*Line template used to give a version.
If nil the line is not inserted.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-version-tag'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-end-block-template nil "\
*Javadoc end comment block characters.
If nil \"*/\" is inserted.
See `jde-javadoc-autodoc-at-line' for usage.  Define the template
variable `tempo-template-jde-javadoc-end-block'." :group 'jde-javadoc :type '(choice :tag "Template form" (text :format "%t
%v" :tag "String") (repeat :tag "Lisp Expressions" (sexp :tag ""))) :set 'jde-javadoc-define-template)

(defcustom jde-javadoc-check-undeclared-exception-flag nil "\
*non-nil means to check for undeclared exceptions.
When an exception is implicitly declared (inherits from
RuntimeException) any associated @exception/@throws tag that already
exists will be just kept without issuing a warning.  Other extra tags
are automatically removed.

If nil extra @exception/@throws tags are never removed but warnings
are issued for (maybe) undeclared exceptions." :group 'jde-javadoc :type 'boolean)

(defcustom jde-javadoc-checker-level 'protected "\
*Accessibility level to check.
Only 'type, 'function or 'variable tags with this level will be
checked.  The level is defined to be consistent with the javadoc show
options.  That is:

- - public    - check only public classes and members.
- - protected - check only protected and public classes and
                members.  This is the default.
- - package   - check only package, protected, and public classes
                and members.
- - private   - check all classes and members." :group 'jde-javadoc :type '(choice :tag "level" (const :tag "public" public) (const :tag "protected" protected) (const :tag "package" package) (const :tag "private" private)))

;;;***

;;;### (autoloads (jde-jdb-key-bindings) "jde-jdb" "lisp/jde-jdb.el")
(defconst custom-define-current-source-file "jde-jdb.el")

(defcustom jde-jdb-key-bindings (list (cons "[? ? ?]" 'jde-debug-step-over) (cons "[? ? ?]" 'jde-debug-step-into) (cons "[? ? ?]" 'jde-debug-step-out) (cons "[? ? ?]" 'jde-debug-cont) (cons "[? ? ?]" 'jde-debug-run) (cons "[? ? ?]" 'jde-debug-toggle-breakpoint) (cons "[? ? ?]" 'jde-debug-up) (cons "[? ? ?]" 'jde-debug-down) (cons "[? ? ?]" 'jde-jdb-print) (cons "[? ? ?]" 'jde-jdb-dump) (cons "[? ? ?]" 'jde-jdb-eval) (cons "[? ? ?]" 'jde-jdb-set) (cons "[? ? ?\^L]" 'jde-jdb-locals)) "\
*Specifies key bindings for jdb debug commands.
The value of this variable is an association list. The car of
each element specifies a key sequence. The cdr specifies 
an interactive command that the key sequence executes. To enter
a key with a modifier, type C-q followed by the desired modified
keystroke. For example, to enter C-s (Control s) as the key to be
bound, type C-q C-s in the key field in the customization buffer.
You can use the notation [f1], [f2], etc., to specify function keys." :group 'jde-project :type '(repeat (cons :tag "Key binding" (string :tag "Key") (function :tag "Command"))) :set '(lambda (sym val) (if (and (boundp 'jde-jdb-key-bindings) jde-jdb-key-bindings) (mapc (lambda (binding) (let ((key (car binding)) (fcn (cdr binding))) (if (string-match "\\[.+]" key) (setq key (car (read-from-string key)))) (define-key jde-jdb-mode-map key nil))) jde-jdb-key-bindings)) (mapc (lambda (binding) (let ((key (car binding)) (fcn (cdr binding))) (if (string-match "\\[.+]" key) (setq key (car (read-from-string key)))) (define-key jde-jdb-mode-map key fcn))) val) (set-default sym val)))

;;;***

;;;### (autoloads (jde-junit-add-test-to-suite-template jde-junit-test-class-template jde-junit-tester-name-tag jde-junit-testrunner-type jde-junit-working-directory jde-junit) "jde-junit" "lisp/jde-junit.el")
(defconst custom-define-current-source-file "jde-junit.el")

(defgroup jde-junit nil "JDE JUnit" :group 'jde :prefix "jde-junit-")

(defcustom jde-junit-working-directory "" "\
*Path of the working directory for the test run.
If you specify a path, the JDE launches the test run from the
directory specified by the path. Otherwise the test run will be launched 
from the current buffer's directory" :group 'jde-junit :type 'file)

(defcustom jde-junit-testrunner-type "junit.textui.TestRunner" "\
Defines the test runner to be used. If you specify a custom
test runner, enter the class name of the test runner in the
edit field." :group 'jde-junit :tag "Test Runner" :type '(choice (const :tag "Text UI" :value "junit.textui.TestRunner") (const :tag "Swing GUI" :value "junit.swingui.TestRunner") (const :tag "AWT GUI" :value "junit.awtui.TestRunner") (string :tag "Custom UI")))

(defcustom jde-junit-tester-name-tag (cons "T" "prefix") "\
Specifies a tag appended or prefixed to the name of a testee class to
create the name of the corresponding tester class, e.g., T or Test, as
in TFoo or FooTest." :group 'jde-junit :tag "Test Class Name Tag" :type '(cons (string :tag "Tag" :value "T") (choice :tag "Tag Type" (const :tag "Prefix" :value t) (const :tag "Suffix" :value nil))))

(defcustom jde-junit-test-class-template (list "(funcall jde-gen-boilerplate-function)" "(jde-gen-get-package-statement)" "\"import junit.framework.Test;\" '>'n" "\"import junit.framework.TestCase;\" '>'n" "\"import junit.framework.TestSuite;\" '>'n" "'n" "(progn (require 'jde-javadoc) (jde-javadoc-insert-start-block))" "\" * \"" "\" Unit Test for class \"" "(jde-junit-get-testee-name (file-name-sans-extension (file-name-nondirectory buffer-file-name))) '>'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert-empty-line)" "\" * Created: \" (current-time-string) '>'n" "\" \" (jde-javadoc-insert-empty-line)" "\" \" (jde-javadoc-insert 'tempo-template-jde-javadoc-author-tag)" "\" \" (jde-javadoc-insert 'tempo-template-jde-javadoc-version-tag)" "\" \" (jde-javadoc-insert 'tempo-template-jde-javadoc-end-block \"*/\")" "\"public class \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" extends TestCase \" " "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "'n" " \" /** \" '>'n" " \"* Creates a new <code>\"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\"</code> instance.\" '>'n" " \"*\" '>'n" " \"* @param name test name\" '>'n" " \"*/\"'>'n" "\"public \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\" (String name)\"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"super(name);\"'>'n" "\"}\"'>" "'>'n" "'n" "\"/**\" '>'n" "\"* @return a <code>TestSuite</code>\" '>'n" "\"*/\" '>'n" "\"public static TestSuite suite()\" '>" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"TestSuite suite = new TestSuite ();\" '>'n" "'>'n" "\"return suite;\" '>'n" "\"}\"'>'n'n" "\"/** \" '>'n" "\"* Entry point \" '>'n" "\"*/ \" '>'n" "\"public static void main(String[] args) \"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"junit.textui.TestRunner.run(suite());\"'>'n" "\"}\"'>'n" "\"}\">" "\"// \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "'>'n") "\
*Template for new Java class.
Setting this variable defines a template instantiation
command `jde-junit-test-class', as a side-effect." :group 'jde-junit :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-junit-test-class-internal (tempo-define-template "java-junit-test-class-buffer-template" (jde-gen-read-template val) nil "Insert a generic JUnit test class buffer skeleton.")) (set-default sym val)))

(defcustom jde-junit-add-test-to-suite-template '("\"suite.addTest(new \"" "(file-name-sans-extension (file-name-nondirectory buffer-file-name))" "\"(\\\"\" (P \"Test Name: \") \"\\\") \"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "\"public void runTest()\"" "(if jde-gen-k&r " "()" "'>'n)" "\"{\"'>'n" "(P \"Method to call: \") \"();\"'>'n" "\"}\"'>'n" "\"});\"'>'n") "\
*Template for generating a test case for suite." :group 'jde-junit :type '(repeat string) :set '(lambda (sym val) (defalias 'jde-junit-add-test-to-suite-internal (tempo-define-template "Adding JUnit test to suit" (jde-gen-read-template val) nil "Insert JUnit test to suite.")) (set-default sym val)))

;;;***

;;;### (autoloads (jde-read-make-args jde-make-finish-hook jde-make-args jde-make-working-directory jde-make-program jde-make) "jde-make" "lisp/jde-make.el")
(defconst custom-define-current-source-file "jde-make.el")

(defgroup jde-make nil "JDE Make Interface" :group 'jde :prefix "jde-make-")

(defcustom jde-make-program "make" "\
*Specifies name of make program." :group 'jde-make :type 'string)

(defcustom jde-make-working-directory "" "\
*Path of the working directory to use in 'make' build mode. This
string must end in a slash, for example, c:/foo/bar/ or ./  .
If this string is empty, the 'make' build mode uses the current file
location as its working directory." :group 'jde-make :type 'string)

(defcustom jde-make-args "" "\
*Specifies arguments to be passed to make program." :group 'jde-make :type 'string)

(defcustom jde-make-finish-hook '(jde-compile-finish-refresh-speedbar jde-compile-finish-update-class-info) "\
List of functions to be invoked when compilation of a 
Java source file terminates. Each function should accept
two arguments: the compilation buffer and a string 
describing how the compilation finished." :group 'jde-make :type 'hook)

(defcustom jde-read-make-args nil "\
*Specify whether to prompt for additional make arguments.
If this variable is non-nil, and if `jde-build-use-make' is non nil
the jde-build command prompts you to enter additional make
arguments in the minibuffer. These arguments are appended to those 
specified by customization variables. The JDE maintains a history 
list of arguments entered in the minibuffer." :group 'jde-make :type 'boolean)

;;;***

;;;### (autoloads (jde-open-class-at-point-find-file-function) "jde-open-source" "lisp/jde-open-source.el")
(defconst custom-define-current-source-file "jde-open-source.el")

(defcustom jde-open-class-at-point-find-file-function 'find-file-other-window "\
Define the function for opening the class at point. See
`jde-open-class-at-point'`. Default is `find-file-other-window'. A function
defined here must have the same signature as `find-file' means the first
argument is the filename and the second optional argument is a
wildcard-pattern." :group 'jde-project :type '(function :tag "Function to open class at point"))

;;;***

;;;### (autoloads (jde-package-search-classpath-variables jde-package-default-package-comment jde-package-package-comment jde-package-load-hook jde-package) "jde-package" "lisp/jde-package.el")
(defconst custom-define-current-source-file "jde-package.el")

(defgroup jde-package nil "jde-package package customization" :group 'jde :prefix "jde-package-")

(defcustom jde-package-load-hook nil "\
*Hook run when package has been loaded." :group 'jde-package :type 'hook)

(defcustom jde-package-package-comment " // Generated package name" "\
*Java line comment appended to the generated package statement.
An empty string suppress the generation of this comment." :group 'jde-package :type 'string)

(defcustom jde-package-default-package-comment "// Default package used" "\
*Java line comment generated when the default package is used.
An empty string suppress the generation of this comment." :group 'jde-package :type 'string)

(defcustom jde-package-search-classpath-variables '(jde-compile-option-classpath jde-global-classpath) "\
*Specify the variables where to search the current classpath list.
The first one which has a non nil value will be used by jde-package." :group 'jde-package :type '(repeat variable))

;;;***

;;;### (autoloads (jde-auto-parse-max-buffer-size jde-auto-parse-buffer-interval jde-auto-parse-enable) "jde-parse" "lisp/jde-parse.el")
(defconst custom-define-current-source-file "jde-parse.el")

(defcustom jde-auto-parse-enable t "\
Enables automatic reparsing of a Java source buffer.
After you makes changes to the buffer, but only if the buffer is less
than `jde-auto-parse-max-buffer-size'." :group 'jde-project :type 'boolean)

(defcustom jde-auto-parse-buffer-interval 180 "\
Time in seconds between buffer change and reparse.
That is between the time between you change a Java source buffer and
the time the JDE reparses the buffer." :group 'jde-project :type 'number)

(defcustom jde-auto-parse-max-buffer-size 50000 "\
Maximum size in bytes of buffers automatically reparsed.
Used when `jde-auto-parse-enable' is non-nil.  Setting the threshold
to 0 causes the JDE to parse a buffer automatically regardless of its
size." :group 'jde-project :type 'number)

;;;***

;;;### (autoloads (jde-plugins-directory) "jde-plugins" "lisp/jde-plugins.el")
(defconst custom-define-current-source-file "jde-plugins.el")

(defcustom jde-plugins-directory (expand-file-name "plugins" (jde-root)) "\
Location of the JDEE's plugins directory." :group 'jde :type 'file)

;;;***

;;;### (autoloads (jde-project-hooks jde-project-file-name jde-project-name jde-project-context-switching-enabled-p jde-project) "jde-project-file" "lisp/jde-project-file.el")
(defconst custom-define-current-source-file "jde-project-file.el")

(defgroup jde-project nil "JDE Project Options" :group 'jde :prefix "jde-")

(defcustom jde-project-context-switching-enabled-p t "\
*Enable project context switching.
If non-nil, the JDE reloads a buffer's project file when you switch to the buffer from
another buffer belonging to another project. You can disable this feature if you prefer
to load project files manually. The debugger uses this variable to disable context-switching
temporarily when stepping through code." :group 'jde-project :type 'boolean)

(defcustom jde-project-name "default" "\
Specifies name of project to which the current buffer belongs." :group 'jde-project :type 'string)

(defcustom jde-project-file-name "prj.el" "\
*Specify name of JDE project file.
When it loads a Java source file, the JDE looks for a lisp file of
this name (the default is prj.el in the source file hierarchy. If it
finds such a file, it loads the file. You can use this file to set the
classpath, compile options, and other JDE options on a
project-by-project basis." :group 'jde-project :type 'string)

(defcustom jde-project-hooks nil "\
Specifies a list of functions to be run when a project
becomes active. The JDE runs the project hooks after
the jde-mode hooks." :group 'jde-project :type '(repeat (function :tag "Function")))

;;;***

;;;### (autoloads (jde-run-executable-args jde-run-executable jde-appletviewer-option-vm-args jde-appletviewer-option-encoding jde-run-applet-doc jde-run-applet-viewer jde-run-option-application-args jde-run-option-vm-args jde-run-option-disable-system-assertions jde-run-option-enable-system-assertions jde-run-option-disable-assertions jde-run-option-enable-assertions jde-run-option-hotspot-type jde-run-option-jar jde-run-option-interpret-mode jde-run-option-debug jde-run-option-boot-classpath jde-run-option-verify jde-run-option-heap-profile jde-run-option-java-profile jde-run-option-garbage-collection jde-run-option-stack-size jde-run-option-heap-size jde-run-option-properties jde-run-option-verbose jde-run-option-classpath jde-run-options jde-run-read-app-args jde-run-read-vm-args jde-run-classic-mode-vm jde-vm-path jde-run-working-directory jde-run-application-class jde-run-mode-hook) "jde-run" "lisp/jde-run.el")
(defconst custom-define-current-source-file "jde-run.el")

(defcustom jde-run-mode-hook nil "\
*List of hook functions run by `jde-run-mode' (see `run-hooks')." :group 'jde-project :type 'hook)

(defcustom jde-run-application-class "" "\
*Name of the Java class to run. 
This is the class that is run if you select JDE->Run App from the JDE
menu or type C-c C-v C-r. If this option is the empty string, the JDE
runs the class corresponding to the source file in the current
buffer. Note that the specified class must have a static public main
method." :group 'jde-project :type 'string)

(defcustom jde-run-working-directory "" "\
*Path of the working directory for this application.
If you specify a path, the JDE launches the application from the
directory specified by the path." :group 'jde-project :type 'file)

(defcustom jde-vm-path "" "\
*Path of the Java virtual machine executable. The path
can include environment variables, e.g.,
$JDK_HOME/bin/java. If the value of this variable is the
empty string, the JDE uses the vm that comes with the
version of the JDK specified by jde-jdk or, if jde-jdk
is not set, the vm on the system command path." :group 'jde-project :type 'file)

(defcustom jde-run-classic-mode-vm nil "\
Runs applications in the classic (i.e., not HotSpot) mode." :group 'jde-project :type 'boolean)

(defcustom jde-run-read-vm-args nil "\
*Read vm arguments from the minibuffer.
If this variable is non-nil, the jde-run command reads vm arguments
from the minibuffer and appends them to those specified by
the `jde-run-option' variable group." :group 'jde-project :type 'boolean)

(defcustom jde-run-read-app-args nil "\
*Read arguments to be passed to application from the minibuffer." :group 'jde-project :type 'boolean)

(defgroup jde-run-options nil "JDE Interpreter Options" :group 'jde :prefix "jde-run-option-")

(defcustom jde-run-option-classpath "global" "\
*Specify paths of classes required to run this application.
Choose Global from the customization buffer value menu to use 
the paths specified by `jde-global-classpath'.
Choose Local from the menu to override the
`jde-global-classpath' option. Choose None to specify
no classpath." :group 'jde-run-options :type '(choice (const :menu-tag "Global" "global") (repeat :menu-tag "Local" (file :tag "Path")) (const :menu-tag "None" "none")))

(defcustom jde-run-option-verbose (list nil nil nil) "\
*Print messages about the running process.
The messages are printed in the run buffer." :group 'jde-run-options :type '(list :indent 2 (checkbox :format "
  %[%v%] %h 
" :doc "Print classes loaded.
Prints a message in the run buffer each time a class is loaded.") (checkbox :format "%[%v%] %h 
" :doc "Print memory freed.
Prints a message in the run buffer each time the garbage collector
frees memory.") (checkbox :format "%[%v%] %h 
" :doc "Print JNI info.
Prints JNI-related messages including information about which native
methods have been linked and warnings about excessive creation of
local references.")))

(defcustom jde-run-option-properties nil "\
*Specify property values.
Enter the name of the property, for example, awt.button.color, in the
Property Name field; enter its value, for example, green, in the
Property Value field. You can specify as many properties as you like." :group 'jde-run-options :type '(repeat (cons (string :tag "Property Name") (string :tag "Property Value"))))

(defcustom jde-run-option-heap-size (list (cons 1 "megabytes") (cons 16 "megabytes")) "\
*Specify the initial and maximum size of the interpreter heap." :group 'jde-run-options :type '(list (cons (integer :tag "Start") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes"))) (cons (integer :tag "Max") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes")))))

(defcustom jde-run-option-stack-size (list (cons 128 "kilobytes") (cons 400 "kilobytes")) "\
*Specify size of the C and Java stacks." :group 'jde-run-options :type '(list (cons (integer :tag "C Stack") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes"))) (cons (integer :tag "Java Stack") (radio-button-choice (const "bytes") (const "kilobytes") (const "megabytes") (const "gigabytes")))))

(defcustom jde-run-option-garbage-collection (list t t) "\
*Specify garbage collection options." :group 'jde-run-options :type '(list :indent 2 (checkbox :format "%[%v%] %t 
" :tag "Collect garbage asynchronously.") (checkbox :format "%[%v%] %t 
" :tag "Collect unused classes.")))

(defcustom jde-run-option-java-profile (cons nil "./java.prof") "\
*Enable Java profiling." :group 'jde-run-options :type '(cons boolean (file :tag "File" :help-echo "Specify where to put profile results here.")))

(defcustom jde-run-option-heap-profile (cons nil (list "./java.hprof" 5 20 "Allocation objects")) "\
*Output heap profiling data." :group 'jde-run-options :type '(cons boolean (list (string :tag "Output File Path") (integer :tag "Stack Trace Depth") (integer :tag "Allocation Sites") (radio-button-choice :format "%t 
%v" :tag "Sort output based on:" (const "Allocation objects") (const "Live objects")))))

(defcustom jde-run-option-verify (list nil t) "\
*Verify classes." :group 'jde-run-options :type '(list :indent 2 (checkbox :format "%[%v%] %t 
" :tag "Executed code in all classes.") (checkbox :format "%[%v%] %t 
" :tag "Classes loaded by a classloader.")))

(defcustom jde-run-option-boot-classpath nil "\
Specify a list of directories, JAR archives, and ZIP archives to
search for boot class files.

To specify the standard boot classpath, select \"standard\" from the
Value Menu. To specify a custom boot classpath, select \"custom\" from
the Value Menu. Emacs displays a \"Custom Mode\" Value Menu and an
\"INS\" button for creating a list of directories and/or JAR and ZIP
archives. To append the custom list to the standard list, select
\"append\" from the Value Menu.  To prepend the custom list to the
standard list, select \"prepend\" from the Value Menu. To replace the
standard list with the custom list, select \"replace\" from the Value
Menu. 

Note that if `jde-jdk' specifies the 1.2.x version of the JDK, the
JDEE replaces the standard list with the custom list regardless of the
setting of the \"Custom Mode\" Value Menu. The JDEE ignores this
option if `jde-jdk' specifies the 1.1.x version of the JDK.

Note also that the value of this variable is either nil or a cons
whose cdr is a list of strings, each of which specifies a path. The
JDE converts this list to a colon- or semicolon-separated list before
inserting it in the compiler or vm command line. The paths may start
with a tilde (~) and may include environment variables. The JDE
replaces the ~ with your home directory and replaces each instance of
an environment variable with its value before inserting it into a
command line. The paths may also start with a . (period) to indicate
that the path is a relative path. If `jde-resolve-relative-paths-p' is
nonnil, the JDEE treats the paths as relative to the location of the
project file for the current project and replaces the period (.) with
the path of the directory containing the project file." :group 'jde-run-options :type '(choice :tag "Classpath Options" (const :tag "standard" nil) (cons :tag "custom" :inline nil (choice :tag "Custom Mode" (const "append") (const "prepend") (const "replace")) (repeat :tag "Classpath" (file :tag "Path")))))

(defcustom jde-run-option-debug nil "\
*If \"Connect\" is selected, this option allows the application to
  start and then connect to a debugger, for example, jdb or JDEbug.

\"Mode\" specifies the method for establishing the connection. The
options are \"Server\" (allow a debugger to attach to the application
after the application starts) or \"Client\" (allows the application to connect 
to a listening debugger).

\"Data Transport\" specifies the method that the debuggee process uses to
communicate with the debugger. The \"Shared Memory\" option is valid
only when the the debuggee process and the debugger are both running
on the same Microsoft Windows system. (It is also the best choice for
such debugging sessions.) You must choose \"Socket\" if the debugger
and the debuggee process run on different systems or if they both
run on the same Unix system.

The \"Shared Memory Name\" option specifies the name of the shared
memory connection used to connect the debugger and the application.
This option applies only when you specify a shared memory connection
to the debugger.

The \"Socket Host\" specifes the host on which a remote debugger
resides. This option applies only when you run the process in 
client mode, using a socket transport.
 
The \"Socket Port\" option specifies the socket port used to 
connect this process to the debugger. This option applies only
when you select socket as the transport method.

The \"Suspend\" option specifies whether the vm should suspend
this process on startup." :group 'jde-run-options :type '(choice :tag "Debug Connection Options" (const :tag "No connect" nil) (list :tag "Connect" :inline nil (choice :tag "Mode" (const "Server") (const "Client")) (choice :tag "Data Transport" (const "Shared Memory") (const "Socket")) (choice :tag "Shared Memory Name" (const :menu-tag "Default" "javadebug") (string :menu-tag "Custom" :tag "Name")) (choice :tag "Socket Host" (const :menu-tag "Local" nil) (string :menu-tag "Remote" :tag "Name")) (choice :tag "Socket Port" (const :menu-tag "Default" "4444") (string :menu-tag "Custom" :tag "Address")) (choice :tag "Suspend?" (const :tag "No" nil) (const :tag "Yes" t)))))

(defcustom jde-run-option-interpret-mode nil "\
Causes the vm to interpret all byte codes. By default VMs
predating JDK 1.3 use a JIT compiler to execute bytecodes. A JIT
compiler translates the class bytecodes into native machine code when
a class is loaded. Beginning with JDK 1.3, VMs use a Hotspot
compiler. A Hotspot compiler compiles sections of code that execute
frequently." :group 'jde-run-options :type 'boolean)

(defcustom jde-run-option-jar nil "\
Execute a program encapsulated in a JAR file.
Set `jde-run-application-class' to the name of a JAR file instead of a
startup class name. In order for this option to work, the manifest of
the JAR file must contain a line of the form Main-Class:
classname. Here, classname identifies the class having the public
static void main(String[] args) method that serves as your
application's starting point. See the Jar tool reference page and the
Jar trail of the Java Tutorial for information about working with Jar
files and Jar-file manifests.  When you use this option, the JAR file
is the source of all user classes, and other user class path settings
are ignored." :group 'jde-run-options :type 'boolean)

(defcustom jde-run-option-hotspot-type 'client "\
Specify whether to use the Hotspot client or server vm." :group 'jde-run-options :type '(choice :tag "vm type" (const :tag "client" client) (const :tag "server" server)))

(defcustom jde-run-option-enable-assertions "Nowhere" "\
Enable assertions for the current project. 

To disable assertions everywhere (the default), select \"Nowhere\"
from the Value Menu. To enable assertions everywhere except in system
classes, select \"Everywhere\" from the Value Menu. To enable
assertions in specific locations, select \"Somewhere\" from the Value
Menu. The customization buffer expands, allowing you to enable
assertions in the package in the current directory (the directory of
the current Java source buffer), and in specific packages and classes.

To enable assertions everwhere except in specified locations, set this
option to \"Everywhere\" and use `jde-run-option-disable-assertions'
to specify the exceptions. To enable assertions in system classes, set
`jde-run-option-enable-system-assertions' on.

The JDEE  ignores this option if `jde-jdk' specifies a version
of the JDK that precedes version 1.4, which 
introduced assertions into Java." :group 'jde-run-options :type '(choice :tag "Enable assertions" (const "Nowhere") (const "Everywhere") (cons :tag "Somewhere" :inline "Everywhere" (boolean :tag "In current directory") (repeat :tag "In the following locations" (cons :tag "Location" (choice :tag "Type" (const "package") (const "class")) (string :tag "Name"))))))

(defcustom jde-run-option-disable-assertions "Nowhere" "\
Enable assertions.

Use this option to specify exceptions to packages and classes enabled
by `jde-run-option-enable-assertions'. To not disable assertions
anywhere (the default), select \"Nowhere\" from the Value Menu. To
disable assertions everywhere except in system classes, select
\"Everywhere except system\" from the Value Menu or set
`jde-run-option-enable-system-assertions' on.  To disable assertions
in specific locations, select \"Somewhere\" from the Value Menu. The
customization buffer expands, allowing you to enable assertions in the
package in the current directory (the directory of the current Java
source buffer), and in specific packages and classes.

The JDEE  ignores this option if `jde-jdk' specifies a version
of the JDK that precedes version 1.4, which 
introduced assertions into Java." :group 'jde-run-options :type '(choice :tag "Disable assertions" (const "Nowhere") (const "Everywhere") (cons :tag "Somewhere" :inline "Everywhere" (boolean :tag "In current directory") (repeat :tag "In the following locations" (cons :tag "Location" (choice :tag "Type" (const "package") (const "class")) (string :tag "Name"))))))

(defcustom jde-run-option-enable-system-assertions nil "\
Enable assertions in system classes." :group 'jde-run-options :type 'boolean)

(defcustom jde-run-option-disable-system-assertions nil "\
Disable assertions in system classes." :group 'jde-run-options :type 'boolean)

(defcustom jde-run-option-vm-args nil "\
*Specify arguments to be passed to the Java vm.
This option allows you to specify one or more arguments to be passed
to the Java interpreter. It is an alternative to using JDE Run Option
variables, such as `jde-run-option-stack-size', to specify Java
interpreter options. Also, it makes it possible to use the JDE with
interpreters that accept command line arguments not supported by 
the JDE Run Option variable set." :group 'jde-run-options :type '(repeat (string :tag "Argument")))

(defcustom jde-run-option-application-args nil "\
*Specify command-line arguments to pass to the application.
The JDE passes the specified arguments to the application on
the command line." :group 'jde-run-options :type '(repeat (string :tag "Argument")))

(defcustom jde-run-applet-viewer "" "\
*Specify name of viewer to use to display page containing the applet." :group 'jde-project :type 'file)

(defcustom jde-run-applet-doc "" "\
*Specify name of document containing applet to be viewed.
If no document is specified, JDE assumes that the document name is
APPLET.html, where APPLET is the name of the applet to be viewed." :group 'jde-project :type 'file)

(defcustom jde-appletviewer-option-encoding "" "\
*Specify encoding of the HTML file displayed by the appletviewer." :group 'jde-run-options :type 'string)

(defcustom jde-appletviewer-option-vm-args nil "\
*Specify arguments (e.g., -Xmx16m) to the vm that runs appletviewer.
This option allows you to set the environment of the
virtual machine that runs appletviewer." :group 'jde-run-options :type '(repeat (string :tag "Argument")))

(defcustom jde-run-executable "" "\
*Specifies the executable to be run by the JDE's run command.
If you do not specify an executable, the JDE runs the vm specified
by `jde-run-get-vm'." :group 'jde-project :type 'file)

(defcustom jde-run-executable-args nil "\
*Specify arguments to be passed to the application executable.
This option allows you to specify one or more arguments to be passed
to the executable specified by `jde-run-executable'." :group 'jde-run-options :type '(repeat (string :tag "Argument")))

;;;***

;;;### (autoloads (tree-widget-node-handle-widget tree-widget) "jde-tree-widget" "lisp/jde-tree-widget.el")
(defconst custom-define-current-source-file "jde-tree-widget.el")

(defgroup tree-widget nil "Customization support for the Tree Widget Library." :group 'widgets)

(defcustom tree-widget-node-handle-widget 'tree-widget-node-handle "\
Widget type used for tree node handle." :type 'symbol :group 'tree-widget)

;;;***

;;;### (autoloads (jde-which-method-abbrev-symbol jde-which-method-class-min-length jde-which-method-max-length jde-mode-line-format jde-which-method-format jde-which-method-mode jde-which-method) "jde-which-method" "lisp/jde-which-method.el")
(defconst custom-define-current-source-file "jde-which-method.el")

(defgroup jde-which-method nil "Mode to display the current function name in the modeline." :group 'jde)

(defcustom jde-which-method-mode t "\
Enables the JDE's which method mode.
When which method mode is enabled, the current method name is
displayed in the mode line." :group 'jde-which-method :type 'boolean)

(defcustom jde-which-method-format '("[" jde-which-method-current "]") "\
Format for displaying the function in the mode line." :group 'jde-which-method :type 'sexp)

(defcustom jde-mode-line-format '("-" mode-line-mule-info mode-line-modified mode-line-frame-identification mode-line-buffer-identification "   " global-mode-string "   %[(" mode-name mode-line-process minor-mode-alist "%n" ")%]--" (line-number-mode "L%l--") (column-number-mode "C%c--") (-3 . "%p") (jde-which-method-mode ("--" jde-which-method-format "--")) "-%-") "\
Format for the JDE source buffer mode line." :group 'jde :type 'sexp)

(defcustom jde-which-method-max-length 20 "\
Specify the maximum length of the which-method-string (see
`jde-which-method-format'). If nil, the string is not truncated." :type '(choice (const :tag "No truncation" :value nil) (integer :tag "Max. length")) :group 'jde-which-method)

(defcustom jde-which-method-class-min-length 4 "\
Specifies the minimum length of the class part of the full method
name after truncation of the class name, but only if the class 
is displayed and if `jde-which-method-max-length'
is not nil. If the full method name is still greater than
`jde-which-method-max-length', the method part of the name is truncated." :type '(integer :tag "Min. length") :group 'jde-which-method)

(defcustom jde-which-method-abbrev-symbol "~" "\
Symbol used to indicate abbreviated part of a method name." :group 'jde-which-method :type 'string)

;;;***

;;;### (autoloads (jde-wiz-tostring-static-members jde-wiz-tostring-postfix jde-wiz-tostring-prefix jde-wiz-tostring-variable-separator jde-wiz-tostring-stringbuffer-size jde-wiz-tostring-sort-variables jde-wiz-get-set-methods-order jde-wiz-get-set-static-members jde-wiz-get-set-methods-include jde-wiz-get-set-variable-convention jde-wiz-show-report jde-wiz-set-javadoc-template jde-wiz-get-javadoc-template jde-wiz-get-set-variable-prefix jde-wiz-include-javadoc jde-wiz) "jde-wiz" "lisp/jde-wiz.el")
(defconst custom-define-current-source-file "jde-wiz.el")

(defgroup jde-wiz nil "JDE Wizards" :group 'jde :prefix "jde-wiz-")

(defcustom jde-wiz-include-javadoc t "\
This variables specifies whether javadoc comments should be included in
skeletons created by the `jde-wiz-get-set-methods' function." :group 'jde-wiz :type 'boolean)

(defcustom jde-wiz-get-set-variable-prefix "arg" "\
This variable defines a prefix to be added to argmument names
for the funtion `jde-wiz-get-set-methods'. For example if this
variable is set to \"arg\" the following variable
String name; will produce this method signature:
public String get(String argName)" :group 'jde-wiz :type 'string)

(defcustom jde-wiz-get-javadoc-template (list "/**" "* Gets the value of %n" "*" "* @return the value of %n" "*/") "\
Template used by `jde-wiz-get-set-method' to add the javadoc
to a get method. The %n are replaced by the variable name and
%t by the variable." :group 'jde-wiz :type '(repeat string))

(defcustom jde-wiz-set-javadoc-template (list "/**" "* Sets the value of %n" "*" "* @param %p Value to assign to this.%n" "*/") "\
Template used by `jde-wiz-get-set-method' to add the javadoc to a
set method. The %n are replaced by the variable name, %t by the variable
type and %p for the argument name. In most cases %n and %p are the same
except when `jde-wiz-get-set-variable-prefix' is non nil; in this case the
%p will pick up those changes as well." :group 'jde-wiz :type '(repeat string))

(defcustom jde-wiz-show-report t "\
A non nil value will show a report of the existing get set methods
and the ones added" :group 'jde-wiz :type 'boolean)

(defcustom jde-wiz-get-set-variable-convention (cons "" nil) "\
Use this variable to specify your coding conventions. This variable is used
by the `jde-wiz-get-set-method' to filter the convention from the variable
declared in the buffer from the name of the method. The are 3 options a prefix,
 a postfix, and the first uppercase letter. For example, choosing a prefix and
setting it to '_' means that the '_' will be filtered from all the variable
containing it. So this variable private String _name;  will produce this get
method:
public getName(String name) {
this._name = name
}
A postfix works in a similar way, the third option behaves slighlty different.
For example if the variable is String _strName; this will get filter to name.
It will take everything after the first capitalize letter. A nil value will use
the variable name as it is defined in the buffer." :group 'jde-wiz :type '(cons (string :tag "Enter either the prefix or postfix") (radio-button-choice (const "Prefix") (const "Postfix") (const "Everything after the first upcase letter") (const nil))))

(defcustom jde-wiz-get-set-methods-include (list "Both") "\
Use this variable to set what methods `jde-wiz-get-set-methods' will
insert in the buffer. The options are get methods only, set methods only,
 and both." :group 'jde-wiz :type '(list (radio-button-choice (const "Get only") (const "Set only") (const "Both"))))

(defcustom jde-wiz-get-set-static-members t "\
If on (nonnil), `jde-wiz-get-set-methods' generates getter/setter methods for
private static members of the class in the current buffer." :group 'jde-wiz :type 'boolean)

(defcustom jde-wiz-get-set-methods-order (list "Get followed by set for each field") "\
Use this variable to set the order in which the
get and set methods are going to be inserted by
`jde-wiz-get-set-methods'" :group 'jde-wiz :type '(list (radio-button-choice (const "Get followed by set for each field") (const "Set followed by get for each field") (const "All get methods followed by all set methods") (const "All set methods followed by all get methods"))))

(defcustom jde-wiz-tostring-sort-variables nil "\
*Specifies whether or not to sort the list of variables in the
  generated method or list them in the order defined in the file." :group 'jde-wiz :type 'boolean)

(defcustom jde-wiz-tostring-stringbuffer-size "1000" "\
*Specifies the initial size of the StringBuffer used to create the
  result for the toString().  It is best to set this to a value large
  enough for most of your work to prevent expansion of the
  StringBuffer at runtime.  You can always change the value in the
  generated code to a smaller or larger one as needed." :group 'jde-wiz :type 'string)

(defcustom jde-wiz-tostring-variable-separator "\"  \"" "\
*Specifies the string between each variable to separate them.
  Examples: 2 spaces (the default), a comma and a space, newline, or a
  method call (as long as the return value is a String).

  Note: Remember this must result in a String in Java!" :group 'jde-wiz :type 'string)

(defcustom jde-wiz-tostring-prefix nil "\
*Specifies the string to prepend to the string result.
  Example: getClass().getName()

  Note: Remember this must result in a String in Java!" :group 'jde-wiz :type '(repeat (string :tag "Text")))

(defcustom jde-wiz-tostring-postfix nil "\
*Specifies the string to append to the string result.
  Example: getClass().getName()

  Note: Remember this must result in a String in Java!" :group 'jde-wiz :type '(repeat (string :tag "Text")))

(defcustom jde-wiz-tostring-static-members t "\
If on (nonnil), `jde-wiz-tostring' includes the values of the
 static members of the class in the current buffer." :group 'jde-wiz :type 'boolean)

;;;***

;;;### (autoloads (jde-xref-cache-size jde-xref-store-prefixes jde-xref-db-base-directory jde-xref) "jde-xref" "lisp/jde-xref.el")
(defconst custom-define-current-source-file "jde-xref.el")

(defgroup jde-xref nil "JDEE Class Cross-Reference (Refactoring) Options" :group 'jde :prefix "jde-xref-")

(defcustom jde-xref-db-base-directory "." "\
The path to store the directory which contains the database of
  which function calls which.  The data directory will be called
  \"xrefdb\" and will reside in the directory pointed to at this
  location " :group 'jde-xref :type 'directory)

(defcustom jde-xref-store-prefixes nil "\
A list of what prefixes to specify what references should be
  tracked in the caller database.  Such as: '(\"org.apache\" \"jde\"),
  to keep track of all references to classes that start with
  \"org.apache\" or \"jde\"." :group 'jde-xref :type '(repeat (string :tag "Prefix")))

(defcustom jde-xref-cache-size 3 "\
How much package info to cache in memory at once.  The higher the
  variable is the more memory will be used, but the faster things
  should be." :group 'jde-xref :type 'integer)

;;;***

;;;### (autoloads (jde-find-file-regexp jde-find-granularity jde-find-case-sensitive jde-setnu-mode-enable jde-setnu-mode-threshold jde-resolve-relative-paths-p jde-cygwin-path-converter jde-new-buffer-menu jde-menu-definition jde-log-max jde-mode-abbreviations jde-enable-abbrev-mode jde-enable-senator jde-devel-debug jde-debugger jde-build-function jde-sourcepath jde-lib-excluded-file-names jde-lib-directory-names jde-expand-classpath-p jde-quote-classpath jde-global-classpath jde-jdk-doc-url jde-jdk jde-jdk-registry jde-java-environment-variables jde-launch-beanshell-on-demand-p jde-key-bindings jde-check-version-flag jde) "jde" "lisp/jde.el")
(defconst custom-define-current-source-file "jde.el")

(defgroup jde nil "Java Development Environment" :group 'tools :prefix "jde-")

(defcustom jde-check-version-flag t "\
*Non-nil means to check versions of semantic, eieio, and speedbar.
That is if they meet the requirements for this version of the JDE.
If nil only check if semantic, eieio, and speedbar are available.
See also the function `jde-check-versions'." :group 'jde :type 'boolean)

(defcustom jde-key-bindings (list (cons "[? ? ?]" 'jde-run-menu-run-applet) (cons "[? ? ?]" 'jde-build) (cons "[? ? ?]" 'jde-compile) (cons "[? ? ?]" 'jde-debug) (cons "[? ? ?]" 'jde-find) (cons "[? ? ?]" 'jde-open-class-at-point) (cons "[? ? ?]" 'jde-bsh-run) (cons "[? ? ?\^L]" 'jde-gen-println) (cons "[? ? ?]" 'jde-help-browse-jdk-doc) (cons "[? ? ?]" 'jde-save-project) (cons "[? ? ?]" 'jde-wiz-update-class-list) (cons "[? ? ?]" 'jde-run) (cons "[? ? ?]" 'speedbar-frame-mode) (cons "[? ? ?]" 'jde-jdb-menu-debug-applet) (cons "[? ? ?]" 'jde-help-symbol) (cons "[? ? ?]" 'jde-show-superclass-source) (cons "[? ? ?]" 'jde-open-class-at-point) (cons "[? ? ?]" 'jde-import-find-and-import) (cons "[? ? ?e]" 'jde-wiz-extend-abstract-class) (cons "[? ? ?f]" 'jde-gen-try-finally-wrapper) (cons "[? ? ?i]" 'jde-wiz-implement-interface) (cons "[? ? ?j]" 'jde-javadoc-autodoc-at-line) (cons "[? ? ?o]" 'jde-wiz-override-method) (cons "[? ? ?t]" 'jde-gen-try-catch-wrapper) (cons "[? ? ?z]" 'jde-import-all) (cons "[? ? ?]" 'jde-run-etrace-prev) (cons "[? ? ?]" 'jde-run-etrace-next) (cons "[(control c) (control v) (control ?.)]" 'jde-complete) (cons "[(control c) (control v) ?.]" 'jde-complete-in-line)) "\
*Specifies key bindings for the JDE.
The value of this variable is an association list. The car of
each element specifies a key sequence. The cdr specifies 
an interactive command that the key sequence executes. To enter
a key with a modifier, type C-q followed by the desired modified
keystroke. For example, to enter C-s (Control s) as the key to be
bound, type C-q C-s in the key field in the customization buffer.
You can use the notation [f1], [f2], etc., to specify function keys." :group 'jde-project :type '(repeat (cons :tag "Key binding" (string :tag "Key") (function :tag "Command"))) :set '(lambda (sym val) (mapc (lambda (buf) (save-excursion (set-buffer buf) (when (boundp 'jde-mode-map) (if (and (boundp 'jde-key-bindings) jde-key-bindings) (mapc (lambda (binding) (let ((key (car binding))) (if (string-match "\\[.+]" key) (setq key (car (read-from-string key)))) (local-unset-key key))) jde-key-bindings)) (mapc (lambda (binding) (let ((key (car binding)) (fcn (cdr binding))) (if (string-match "\\[.+]" key) (setq key (car (read-from-string key)))) (define-key (current-local-map) key fcn))) val)))) (jde-get-java-source-buffers)) (set-default sym val)))

(defcustom jde-launch-beanshell-on-demand-p t "\
If non-nil, the JDE launches the Beanshell the first time it is needed.
Otherwise, the JDE launches the Beanshell, if it is not already running,
whenever you open a Java source file." :group 'jde-project :type 'boolean)

(defcustom jde-java-environment-variables '("JAVA_VERSION" "JAVA_HOME") "\
This variable specifies the names of environment variables used to
specify the version and location of the JDK to be used by the JDE.
If set, the `jde-jdk' customization variable overrides the 
java enviroment variables." :group 'jde-project :type '(list (string :tag "Java Version") (string :tag "Java Home")))

(defcustom jde-jdk-registry nil "\
Specifies the versions and locations of the JDKs installed on your
system.  For each JDK to be registered, enter the version number
\(e.g., 1.4.0) of the JDK in the Version field. Enter the path of the
JDK's root directory (e.g., c:/jdk1.3.1 or $JAVA_HOME) in the Path
field. Setting this variable determines the choices offered by the
`jde-jdk' variable. You should therefore customize this variable
first." :group 'jde-project :type '(repeat (cons :tag "JDK" (string :tag "Version") (string :tag "Path"))) :set 'jde-set-jdk-dir-type)

(defcustom jde-jdk nil "\
Specifies the version of the JDK to be used to develop the current
project. The version must be one of the versions listed in the
`jde-jdk-registry'. If you specify nil (the default), the JDE uses the
JDK specified by the Java version environment variable (see
`jde-java-enviroment-variables', if set; otherwise, the first JDK
located on the system command path specified by te PATH environment
variable.

You must customize `jde-jdk-registry' first, then `jde-jdk'. After you
have customized jde-jdk-registry, the customization buffer for`
jde-jdk' presents you with a set of radio buttons, one for each
registered JDK.  Select the button of the JDK that you want to use for
the current project." :group 'jde-project :type 'symbol (if (or (featurep 'xemacs) (< emacs-major-version 21)) :set :set-after) (if (or (featurep 'xemacs) (< emacs-major-version 21)) 'custom-set-default '(jde-jdk-registry)))

(defcustom jde-jdk-doc-url "" "\
*URL of JDK documentation. 
This can point to a remote or local copy of the documentation. If the value
of this variable is the null string, the JDE looks for the JDK documentation
in the docs subdirectory of the directory returned by `jde-get-jdk-dir'." :group 'jde-project :type 'file)

(defcustom jde-global-classpath nil "\
Specify a common classpath for compile, run, and debug commands.
Use this variable if you want to the JDE to use the same classpath for
compiling, running,and debugging an application. Note that the value
of this variable is a list of strings, each of which specifies a
path. The JDE converts this list to a colon- or semicolon-separated
list before inserting in the compiler or vm command line. 

The path may start with a tilde (~) or period (.) and may include
environment variables. The JDEE replaces a ~ with your home directory.
If `jde-resolve-relative-paths-p' is nonnil, the JDEE replaces the
. with the path of the current project file. The JDEE replaces each
instance of an environment variable with its value before inserting it
into the command line.

You can specify different classpaths for compiling, running and
debugging applicaitons. Use `jde-compile-option-classpath' to specify
the compilation classpath, `jde-run-option-classpath' to specify the
run classpath, and/or `jde-db-option-classpath' to specify the debug
classpath. You can use these variables together. For example, suppose
that you need to use one classpath for compilation and other for
running and debugging. You could do this by setting
`jde-compile-option-classpath' to the compile classpath and
`jde-global-classpath' to the run and debug classpath. If you set
`jde-global-classpath', the JDE uses it to construct the classpath for
any operation for which you do not set the operation-specific
classpath variable (e.g., `jde-compile-option-classpath'). 

If you do not set `jde-global-classpath', the JDE uses the operation-specific
classpath if it is set. If neither the global nor the
operation-specific classpath is set, the JDE does not generate a
-classpath argument for the operation, e.g., compile or run a Java
class. In this case, the operation uses the value of the CLASSPATH variable
if specified." :group 'jde-project :type '(repeat (file :tag "Path")))

(defcustom jde-quote-classpath t "\
*Quote the classpath argument.
Set this option on when using the bash shell with Windows 95 or NT.
The semicolons in the classpath confuse the shell." :group 'jde-project :type 'boolean)

(defcustom jde-expand-classpath-p t "\
Replace each occurence of a directory named `jde-lib-directory-names'
 in the classpath with paths to the jar and zip files in that directory." :group 'jde-project :type 'boolean)

(defcustom jde-lib-directory-names (list "^lib" "^jar") "\
Regular expressions that matches names of jar/zip directories for 
the current project. See `jde-expand-classpath-p' and
`jde-expand-classpath' for more information" :group 'jde-project :type '(repeat (string :tag "Name")))

(defcustom jde-lib-excluded-file-names nil "\
Regular expressions that matches names of jar or zip files that should
 be excluded when expanding a library specified by `jde-lib-directory-names'." :group 'jde-project :type '(repeat (string :tag "Name")))

(defcustom jde-sourcepath nil "\
*List of source directory paths.  The JDE uses this list to locate
source files corresponding to class files.  When entering paths in the
custom buffer, enter each path as a separate item in a separate edit
field. Do NOT put more than one path in the same edit field. You'll
only confuse JDE.  Paths may contain environment variables." :group 'jde-project :type '(repeat (file :tag "Path")))

(defcustom jde-build-function '(jde-make) "\
*Function that will be invoked by the `jde-build' command.
The `jde-make' function uses a make 
program to rebuild the project. The `jde-ant-build' function
uses the Apache Ant program to build the project. You may also
specify a custom function to use. The custom function must
be an interactive function that can be called by 
`call-interactively'." :group 'jde-project :type '(list (radio-button-choice :format "%t 
%v" :tag "Function: " :entry-format " %b %v" (const jde-make) (const jde-ant-build) (function my-custom-build-function))))

(defcustom jde-debugger (list "jdb") "\
Specify the debugger you want to use to debug Java programs.
Select JDEbug, if you want to use the JDE's builtin debugger.  Select
jdb, if you want to use the default version of jdb for the JDK used by
the current project (see `jde-jdk'). Select old jdb, if you are using
JDK 1.2.2 or later and want to use the the old (e.g., pre-JPDA)
version of jdb instead of the new (JPDA-based) version of jdb." :group 'jde-project :type '(list (radio-button-choice (item "JDEbug") (item "jdb") (item "old jdb"))) :set '(lambda (sym val) (mapc (lambda (buff) (save-excursion (set-buffer buff) (if (string= (car val) "JDEbug") (progn (jde-jdb-minor-mode -1) (jde-bug-minor-mode 1)) (progn (jde-jdb-minor-mode 1) (jde-bug-minor-mode -1))))) (jde-get-java-source-buffers)) (set-default sym val)))

(defcustom jde-devel-debug nil "\
If true, use the JDEE Java classes in the jde/java/classes
directory instead of the jde.jar. This variable is intended for
use in testing the JDEE's java classes." :group 'jde-project :type 'boolean)

(defcustom jde-enable-senator t "\
Enable senator minor mode.
This mode provides Java-aware buffer navigation and searching
commands." :group 'jde-project :type 'boolean :set '(lambda (sym val) (set-default sym val) (unless (or (not (featurep 'jde)) jde-loading-project (and (boundp 'global-senator-minor-mode) global-senator-minor-mode)) (mapc (lambda (buff) (save-excursion (set-buffer buff) (senator-minor-mode (if val 1 -1)))) (jde-get-java-source-buffers)))))

(defcustom jde-enable-abbrev-mode nil "\
*Enable expansion of abbreviations in jde-mode.
See `jde-mode-abbreviations' for more information." :group 'jde-project :type 'boolean :set '(lambda (sym val) (set-default sym val) (if (featurep 'jde) (mapc (lambda (buf) (with-current-buffer buf (setq abbrev-mode val) (when abbrev-mode (setq local-abbrev-table (make-abbrev-table)) (jde-init-abbrev-table)))) (jde-get-project-source-buffers)))))

(defcustom jde-mode-abbreviations (list (cons "ab" "abstract") (cons "bo" "boolean") (cons "br" "break") (cons "by" "byte") (cons "byv" "byvalue") (cons "cas" "cast") (cons "ca" "catch") (cons "ch" "char") (cons "cl" "class") (cons "co" "const") (cons "con" "continue") (cons "de" "default") (cons "dou" "double") (cons "el" "else") (cons "ex" "extends") (cons "fa" "false") (cons "fi" "final") (cons "fin" "finally") (cons "fl" "float") (cons "fo" "for") (cons "fu" "future") (cons "ge" "generic") (cons "go" "goto") (cons "impl" "implements") (cons "impo" "import") (cons "ins" "instanceof") (cons "in" "int") (cons "inte" "interface") (cons "lo" "long") (cons "na" "native") (cons "ne" "new") (cons "nu" "null") (cons "pa" "package") (cons "pri" "private") (cons "pro" "protected") (cons "pu" "public") (cons "re" "return") (cons "sh" "short") (cons "st" "static") (cons "su" "super") (cons "sw" "switch") (cons "sy" "synchronized") (cons "th" "this") (cons "thr" "throw") (cons "thro" "throws") (cons "tra" "transient") (cons "tr" "true") (cons "vo" "void") (cons "vol" "volatile") (cons "wh" "while")) "\
*Abbreviations used for Java keywords.
To use these abbreviations, you must enable abbrev-mode (see
`jde-enable-abbrev-mode'). To use an abbreviation, enter the
abbreviation followed by a white-space character. To suppress
expansion, enter C-q white-space." :group 'jde-project :type '(repeat (cons :tag "jde-mode abbreviation" (string :tag "Abbreviation") (string :tag "Expansion"))) :set '(lambda (sym val) (set-default sym val) (if (and (featurep 'jde) jde-enable-abbrev-mode) (progn (mapc (lambda (buf) (with-current-buffer buf (setq local-abbrev-table (make-abbrev-table)) (jde-init-abbrev-table))) (jde-get-project-source-buffers))))))

(defcustom jde-log-max 500 "\
*Maximum number of lines to keep in the JDE log buffer.
If nil, disable logging.  If t, don't truncate the buffer." :group 'jde-project :type '(choice (integer :tag "Number of lines to keep") (boolean :tag "Disable/Unlimited")))

(defcustom jde-menu-definition (list "JDE" ["Compile" jde-compile t] ["Run App" jde-run t] ["Debug App" jde-debug t] "-" ["Run Applet" jde-run-menu-run-applet t] ["Debug Applet" jde-debug-applet t] "-" ["Build" jde-build t] (list "Find" ["Expression" jde-find (and (executable-find (if (eq system-type 'windows-nt) "find.exe" "find")) (executable-find (if (eq system-type 'windows-nt) "grep.exe" "grep")))] ["Expression..." jde-find-dlg (and (executable-find (if (eq system-type 'windows-nt) "find.exe" "find")) (executable-find (if (eq system-type 'windows-nt) "grep.exe" "grep")))] ["Symbol Definition" jde-open-class-at-point t] ["Class" jde-show-class-source t] ["Super Class" jde-show-superclass-source t] ["Interface" jde-show-interface-source t]) (list "Interpreter" ["Start" jde-bsh-run t] ["Exit" jde-bsh-exit t] "-" ["Help" jde-help-beanshell t]) (list "Documentation" ["Add" jde-javadoc-autodoc-at-line (jde-javadoc-enable-menu-p)] ["Remove" jde-javadoc-remdoc-at-line (jde-javadoc-enable-menu-p)] ["Check This" jde-javadoc-checkdoc-at-line (jde-javadoc-enable-menu-p)] ["Check All" jde-javadoc-checkdoc t] ["Generate All" jde-javadoc-make t] ["Generate Buffer" jde-javadoc-make-buffer t] "-" ["Javadoc Reference" jde-javadoc-browse-tool-doc t]) "-" (list "Code Generation" (list "Templates" ["Get/Set Pair..." jde-gen-get-set t] ["Println..." jde-gen-println t] (list "Listener" ["Action" jde-gen-action-listener t] ["Change" jde-gen-change-listener t] ["Window" jde-gen-window-listener t] ["Mouse" jde-gen-mouse-listener t]) ["Other..." jde-gen-code t]) (list "Import" ["Class..." jde-import-find-and-import t] ["All" jde-import-all t] ["All Unique" jde-import-all-unique t] "-" ["Expand Package Imports" jde-import-expand-imports t] ["Collapse Class Imports" jde-import-collapse-imports t] ["Delete Unneeded" jde-import-kill-extra-imports t] ["Organize Imports" jde-import-organize t] ["Show Unimported Classes" jde-import-all-show t]) (list "Wizards" ["Override Method" jde-wiz-override-method t] ["Implement Interface..." jde-wiz-implement-interface t] ["Generate Get/Set Methods" jde-wiz-get-set-methods t] ["Generate toString Method" jde-wiz-tostring t] ["Update Package Statement" jde-package-update t] ["Implement Event Source..." jde-wiz-implement-event-source t] ["Extend Abstract Class..." jde-wiz-extend-abstract-class t] ["Delegate Methods..." jde-wiz-delegate t] "-" ["Update Class List" jde-wiz-update-class-list t]) (list "Modes" (vector "Abbrev" 'jde-abbrev-mode (if (featurep 'xemacs) :active :enable) t :style 'toggle :selected 'jde-enable-abbrev-mode) (vector "Electric Return" 'jde-electric-return-mode (if (featurep 'xemacs) :active :enable) t :style 'toggle :selected 'jde-electric-return-mode))) (list "Browse" ["Source Files" jde-show-speedbar t] ["Class at Point" jde-browse-class-at-point t]) ["Check Style" jde-checkstyle] (list "Project" (vector "Auto Switch" 'jde-toggle-project-switching (if jde-xemacsp :active :enable) t :style 'toggle :selected 'jde-project-context-switching-enabled-p) (list "Options" ["General" jde-show-project-options t] ["Compile" jde-compile-show-options-buffer t] ["Run" jde-show-run-options t] ["Debug" jde-show-debug-options t] ["Autocode" jde-show-autocode-options t] ["Javadoc" jde-javadoc-customize t] ["Make" jde-make-show-options t] ["Ant" jde-ant-show-options t] ["Complete" jde-show-complete-options t] ["Wiz" jde-show-wiz-options t]) (list "Project File" ["Create New" jde-create-new-project t] ["Save" jde-save-project t] ["Load" jde-load-project-file t] ["Load All" jde-load-all-project-files t])) (list "Help" ["JDEE Users Guide" jde-show-help t] ["JDK" jde-help-browse-jdk-doc t] ["JDEE Key Bindings" jde-keys t] "-" ["Class..." jde-help-class t] ["Class Member..." jde-help-class-member t] ["Symbol at Point" jde-help-symbol t] "-" ["Submit problem report" jde-submit-problem-report t] "-" (concat "JDE " jde-version))) "\
*The JDE main menu" :group 'jde-project :type 'sexp :set '(lambda (sym val) (set-default sym val) (if (or (not jde-xemacsp) (featurep 'infodock)) (easy-menu-define jde-menu jde-mode-map "Menu for JDE." val)) (if (and jde-xemacsp (eq major-mode 'jde-mode)) (jde-insert-menu-in-xemacs-menubar))))

(defcustom jde-new-buffer-menu (list "JDE New" ["Class..." jde-gen-class-buffer t] ["Interface..." jde-gen-interface-buffer t] ["Console..." jde-gen-console-buffer t] ["Bean..." jde-gen-bean-buffer t] ["Unit Test..." jde-junit-test-class-buffer t] (list "EJB" ["Session Bean" jde-ejb-session-bean-buffer t] ["Entity Bean" jde-ejb-entity-bean-buffer t]) ["Other..." jde-gen-buffer t]) "\
*The JDE New buffer menu" :group 'jde-project :type 'sexp :set '(lambda (sym val) (set-default sym val) (if jde-xemacsp (unless (featurep 'infodock) (when (fboundp 'add-submenu) (add-submenu '("File") val "Insert File..."))) (let* ((menu (if (fboundp 'easy-menu-create-menu) (easy-menu-create-menu (car val) (cdr val)))) (menu-name (car val))) (define-key-after menu-bar-file-menu [jde-new] (cons menu-name menu) 'open-file)))))

(defcustom jde-cygwin-path-converter '(jde-cygwin-path-converter-internal) "\
Function to use to convert cygwin paths to DOS paths.  
Choose jde-cygwin-path-converter-internal, jde-cygwin-path-converter-cygpath,
or \"custom-function.\" jde-cygwin-path-converter-cygpath handles all
cygwin-style paths, including mount points, e.g.,/bin. 
jde-cygwin-path-converter-internal does not handle mount
paths. However, it is much faster as it does not require running a
subprocess every time the JDE needs to convert a path. Choose
\"custom-function\" if you want the JDE to use a function that you
supply. Replace \"custom-function\" with the name of the function that
you want to use." :group 'jde-project :type '(list (radio-button-choice :format "%t 
%v" :tag "Converter: " :entry-format "  %b %v" (const jde-cygwin-path-converter-internal) (const jde-cygwin-path-converter-cygpath) (function custom-function))))

(defcustom jde-resolve-relative-paths-p t "\
If this variable is non-nil, the JDE converts relative paths to 
absolute paths. The JDE does this by appending the relative path to the path
of the project file for the current source buffer, if such
a file exists. Otherwise, the JDE appends the relative path to the path
of the current directory." :group 'jde-project :type 'boolean)

(defcustom jde-setnu-mode-threshold 20000 "\
Maximum number of bytes in a file (buffer) that can result in
automatic line numbering." :group 'jde-project :type 'integer)

(defcustom jde-setnu-mode-enable nil "\
Enable numbering of lines in Java source buffers." :group 'jde-project :type 'boolean :set '(lambda (sym val) (if val (progn (require 'setnu) (add-hook 'after-change-functions 'jde-setnu-after-change) (add-hook 'before-change-functions 'jde-setnu-before-change) (mapc (lambda (buf) (save-excursion (set-buffer buf) (if (and (not setnu-mode) (< (point-max) jde-setnu-mode-threshold)) (setnu-mode 1)))) (jde-get-java-source-buffers))) (progn (mapc (lambda (buf) (save-excursion (set-buffer buf) (if (and (boundp 'setnu-mode) setnu-mode) (setnu-mode)))) (jde-get-java-source-buffers)))) (set-default sym val)))

(defcustom jde-find-case-sensitive nil "\
*Specifies whether the jde-find command performs a case-sensitive search.
If non-nil, the search is case-sensitive; otherwise, the search ignores case." :group 'jde-project :type 'boolean)

(defcustom jde-find-granularity '("Character") "\
*Specifies the granularity of the expression search
conducted by `jde-find': Character (expression starting
on any character), Word (match words only), Line
\(match lines only)." :group 'jde-project :type '(list (radio-button-choice :format "%t 
%v" :tag "Search granularity:" (item "Character") (item "Word") (item "Line"))))

(defcustom jde-find-file-regexp '("*.java") "\
*Specifies the regular expression that the jde-find command uses
to select files to be searched. You can use any regular expression  
supported by the -name option of the GNU find command." :group 'jde-project :type '(repeat (string :tag "Find regexp")))

;;;***

(provide 'jde-custom-defines)
